; 
; @@@@@@@@@@@@@@@@@@@@@@@@@
; @@@kbcvX@Rg[@vO@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@^[~i@@uRDS@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@ʰ޳ : TLX-40 & 40A@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@@@aDmNX@@@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@
; @@@@@@iPXXTN@RQOj@@@@@@
; @@@@@@@@@@@@@@@@@@@@@@@@@
; 

; Operating System	:	MS-DOS
; Assembler		:	XA80 (System_Load)

; File-Name (Source)	:	L_TERM34.ASM
;           (List)	:	L_TERM34.LST
;           (Hex)	:	L_TERM34.HEX
;           (Symbol)	:	L_TERM34.SYM



; ///// Register Diffinition /////

; A : Accumulator		F : Flag
; B : General Purpose		C : General Purpose
; D : General Purpose		E : General Purpose
; H : General Purpose		L : General Purpose

; A': Memory(Accumulator)	F': Flag
; B': Memory(General Purpose)	C': Memory(General Purpose)
; D': SIO Mode(DIP-SW.1)	E': Status_1(EL,Carsol,Blink,Int & Buzzer)
; H': Carsol-X			L': Carsol-Y

; IX : Return Address of Interrupt
; IY : Return Address of Subroutine

; moderg : Status_2


; ///// Constant Diffinition /////

romtop	EQU	0000H		; ROM Top Address
romend	EQU	1FFFH		;     End Address

ramtop	EQU	2000H		; RAM Top Address
ramend	EQU	3FFFH		;     End Address


moderg	EQU	0F0H		; Halt/WDT Mode Register
contrg	EQU	0F1H		;          Controll Register
intpr	EQU	0F4H		; Interrupt Pliority Register

haltcr	EQU	11011011B	; Halt Mode Clear
wdtnot	EQU	10110001B	; WDT Not
wdtpls	EQU	01001110B	;     Pulse
intprd	EQU	00000000B	; Int. Pliority Data

keta	EQU	40		; LCD_Keta_su
gyou0	EQU	2		;     Gyou_su_0
gyou1	EQU	4		;             1



; ///// Communication Controll Code /////

null	EQU	00H		; Null
sh	EQU	01H		; Start of Heading
sx	EQU	02H		; Start of Text
ex	EQU	03H		; End of Text
et	EQU	04H		; End of Transmission
enq	EQU	05H		; Enquiry
ak	EQU	06H		; Acknowledage
bl	EQU	07H		; Bell
bs	EQU	08H		; Back Space
ht	EQU	09H		; Horizontal Tabulation
lf	EQU	0AH		; Line Feed
hm	EQU	0BH		; Home Vertical Tabulation
cl	EQU	0CH		; Clear Form Feed
cr	EQU	0DH		; Carriage Return
so	EQU	0EH		; Sift-Out
si	EQU	0FH		; Sift-In
dle	EQU	10H		; Data Link Escape
d1	EQU	11H		; Device Controll 1
d2	EQU	12H		; Device Controll 2
d3	EQU	13H		; Device Controll 3
d4	EQU	14H		; Device Controll 4
nk	EQU	15H		; Negative Acknowledage
sn	EQU	16H		; Synchronous Idel
eb	EQU	17H		; End of Transmission Block
cn	EQU	18H		; Cancel
em	EQU	19H		; End of Medium
sb	EQU	1AH		; Substitute
ec	EQU	1BH		; Escape
fs	EQU	1CH		; File Separator
gs	EQU	1DH		; Group Separator
rs	EQU	1EH		; Record Separator
us	EQU	1FH		; Unit Separator
spc	EQU	20H		; Space



; ***************************************
; ******    Initial Main Module    ******
; ***************************************

	ORG	0

prgst:	DI
	IM	2
	LD	HL,vcttbl
	LD	A,H
	LD	I,A

	LD	A,haltcr
	OUT	(contrg),A
	LD	A,00011011B
	OUT	(moderg),A
	LD	A,wdtnot
	OUT	(contrg),A
	LD	A,intprd
	OUT	(intpr),A

	JP	pre_main


; ///// IM0 Interrupt /////

	ORG	38H

	LD	SP,IX
	RETI


; ///// NMI /////

	ORG	66H

	LD	SP,IX
	RETN



; *******************************
; ******    Version No.    ******
; *******************************

	ORG	70h

	DB	34h		; Version
	DB	95h,03h,20h	; Date



; ************************************
; ******    Pre Main Program    ******
; ************************************

	ORG	80H

pre_main:
	JP	regini		; Initialize Registor
main00:	JP	pioini		;            PIO
main01:	JP	swread		; Read DIP-Switch
main02:	JP	ctcini		; Initialize CTC
main03:	JP	sioini		;            SIO
main04:	JP	lcdini		;            LCD
main0B:	JP	cgini		;            CG-RAM Data
main05:
	LD	A,(memsw2)	; Title Display ??
	BIT	0,A
	JR	Z,main09

	JP	rsmodd		; RS-232C Mode Display
main08:	JR	C,main09

main09:
	JP	conchk		; RS-232C Connect Check

main0A:
	LD	A,(memsw0)	; LED Back Light On
	BIT	0,A
	JR	Z,main0L
	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
	JR	main0E
main0L:
	LD	A,ctcw2
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

main0E:	LD	A,(lcdbfg)	; Text Clear
	RLA
	JR	C,main0E
	LD	A,lcdcls
	LD	(lcdir),A

	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,main0F
	JR	main0J
main0F:
	LD	A,(lcdbfg2)
	RLA
	JR	C,main0F
	LD	A,lcdcls
	LD	(lcdir2),A

main0J:
	LD	A,(memsw2)	; Initial Carsol
	BIT	3,A
	JR	NZ,main0K
	JR	main0G
main0K:
	LD	A,(lcdbfg)
	RLA
	JR	C,main0K
	LD	A,00001101B
	LD	(lcdir),A
	EXX
	SET	0,E
	RES	1,E
	EXX

main0G:
	JP	main



; ***********************************************
; ******    Interrupt Vct-Address Table    ******
; ***********************************************

	ORG	100H

vcttbl	DW	dmyirt		; <  0> SIO-B Tx-Out
	DW	dmyirt		; <  1>       Status
	DW	dmyirt		; <  2>       Rx-In
	DW	dmyirt		; <  3>       Error
	DW	dmyirt		; <  4> SIO-A Tx-Out
	DW	staint		; <  5>       Status
	DW	sioint		; <  6>       Rx-In
	DW	sioerr		; <  7>       Error

	DW	dmyirt		; <  8> CTC-0
	DW	dmyirt		; <  9>     1
	DW	elint		; < 10>     2
	DW	ctc3_int	; < 11>     3

	DW	dmyirt		; < 12>
	DW	dmyirt		; < 13>
	DW	dmyirt		; < 14>
	DW	dmyirt		; < 15>
	DW	dmyirt		; < 16>
	DW	dmyirt		; < 17>
	DW	dmyirt		; < 18>
	DW	dmyirt		; < 19>

	DW	dmyirt		; < 20>
	DW	dmyirt		; < 21>
	DW	dmyirt		; < 22>
	DW	dmyirt		; < 23>
	DW	dmyirt		; < 24>
	DW	dmyirt		; < 25>
	DW	dmyirt		; < 26>
	DW	dmyirt		; < 27>
	DW	dmyirt		; < 28>
	DW	dmyirt		; < 29>

	DW	dmyirt		; < 30>
	DW	dmyirt		; < 31>
	DW	dmyirt		; < 32>
	DW	dmyirt		; < 33>
	DW	dmyirt		; < 34>
	DW	dmyirt		; < 35>
	DW	dmyirt		; < 36>
	DW	dmyirt		; < 37>
	DW	dmyirt		; < 38>
	DW	dmyirt		; < 39>

	DW	dmyirt		; < 40>
	DW	dmyirt		; < 41>
	DW	dmyirt		; < 42>
	DW	dmyirt		; < 43>
	DW	dmyirt		; < 44>
	DW	dmyirt		; < 45>
	DW	dmyirt		; < 46>
	DW	dmyirt		; < 47>
	DW	dmyirt		; < 48>
	DW	dmyirt		; < 49>

	DW	dmyirt		; < 50>
	DW	dmyirt		; < 51>
	DW	dmyirt		; < 52>
	DW	dmyirt		; < 53>
	DW	dmyirt		; < 54>
	DW	dmyirt		; < 55>
	DW	dmyirt		; < 56>
	DW	dmyirt		; < 57>
	DW	dmyirt		; < 58>
	DW	dmyirt		; < 59>

	DW	dmyirt		; < 60>
	DW	dmyirt		; < 61>
	DW	dmyirt		; < 62>
	DW	dmyirt		; < 63>
	DW	dmyirt		; < 64>
	DW	dmyirt		; < 65>
	DW	dmyirt		; < 66>
	DW	dmyirt		; < 67>
	DW	dmyirt		; < 68>
	DW	dmyirt		; < 69>

	DW	dmyirt		; < 70>
	DW	dmyirt		; < 71>
	DW	dmyirt		; < 72>
	DW	dmyirt		; < 73>
	DW	dmyirt		; < 74>
	DW	dmyirt		; < 75>
	DW	dmyirt		; < 76>
	DW	dmyirt		; < 77>
	DW	dmyirt		; < 78>
	DW	dmyirt		; < 79>

	DW	dmyirt		; < 80>
	DW	dmyirt		; < 81>
	DW	dmyirt		; < 82>
	DW	dmyirt		; < 83>
	DW	dmyirt		; < 84>
	DW	dmyirt		; < 85>
	DW	dmyirt		; < 86>
	DW	dmyirt		; < 87>
	DW	dmyirt		; < 88>
	DW	dmyirt		; < 89>

	DW	dmyirt		; < 90>
	DW	dmyirt		; < 91>
	DW	dmyirt		; < 92>
	DW	dmyirt		; < 93>
	DW	dmyirt		; < 94>
	DW	dmyirt		; < 95>
	DW	dmyirt		; < 96>
	DW	dmyirt		; < 97>
	DW	dmyirt		; < 98>
	DW	dmyirt		; < 99>

	DW	dmyirt		; <100>
	DW	dmyirt		; <101>
	DW	dmyirt		; <102>
	DW	dmyirt		; <103>
	DW	dmyirt		; <104>
	DW	dmyirt		; <105>
	DW	dmyirt		; <106>
	DW	dmyirt		; <107>
	DW	dmyirt		; <108>
	DW	dmyirt		; <109>

	DW	dmyirt		; <110>
	DW	dmyirt		; <111>
	DW	dmyirt		; <112>
	DW	dmyirt		; <113>
	DW	dmyirt		; <114>
	DW	dmyirt		; <115>
	DW	dmyirt		; <116>
	DW	dmyirt		; <117>
	DW	dmyirt		; <118>
	DW	dmyirt		; <119>

	DW	dmyirt		; <120>
	DW	dmyirt		; <121>
	DW	dmyirt		; <122>
	DW	dmyirt		; <123>
	DW	dmyirt		; <124>
	DW	dmyirt		; <125>
	DW	dmyirt		; <126>
	DW	dmyirt		; <127>



; *************************************
; ******    CG-RAM Data Table    ******
; *************************************

	ORG	200H

cgtbl00	DB	11001B		; NL
	DB	10101B
	DB	10011B
	DB	00100B
	DB	00100B
	DB	00100B
	DB	00111B
	DB	00000B

cgtbl01	DB	11000B		; SH
	DB	10000B
	DB	01000B
	DB	11000B
	DB	00101B
	DB	00111B
	DB	00101B
	DB	00000B

cgtbl02	DB	11000B		; SX
	DB	10000B
	DB	01000B
	DB	11000B
	DB	00101B
	DB	00010B
	DB	00101B
	DB	00000B

cgtbl03	DB	11000B		; EX
	DB	10000B
	DB	11000B
	DB	10000B
	DB	11101B
	DB	00010B
	DB	00101B
	DB	00000B

cgtbl04	DB	11000B		; ET
	DB	10000B
	DB	11000B
	DB	10111B
	DB	11010B
	DB	00010B
	DB	00010B
	DB	00000B

cgtbl05	DB	11000B		; EQ(Eq)
	DB	10000B
	DB	11000B
	DB	10111B
	DB	11101B
	DB	00011B
	DB	00001B
	DB	00000B

cgtbl06	DB	11100B		; AK
	DB	10100B
	DB	11100B
	DB	10100B
	DB	00101B
	DB	00110B
	DB	00101B
	DB	00000B

cgtbl07	DB	10000B		; BL(bL)
	DB	10000B
	DB	11100B
	DB	10110B
	DB	11010B
	DB	00010B
	DB	00011B
	DB	00000B

cgtbl08	DB	10000B		; BS(bS)
	DB	10000B
	DB	11100B
	DB	10111B
	DB	11010B
	DB	00001B
	DB	00011B
	DB	00000B

cgtbl09	DB	10100B		; HT
	DB	11100B
	DB	10100B
	DB	00111B
	DB	00010B
	DB	00010B
	DB	00010B
	DB	00000B

cgtbl0A	DB	10000B		; LF
	DB	10000B
	DB	10111B
	DB	11100B
	DB	00110B
	DB	00100B
	DB	00100B
	DB	00000B

cgtbl0B	DB	10100B		; HM
	DB	11100B
	DB	10100B
	DB	00000B
	DB	11011B
	DB	10101B
	DB	10001B
	DB	00000B

cgtbl0C	DB	11100B		; CL
	DB	10000B
	DB	10000B
	DB	11100B
	DB	00100B
	DB	00100B
	DB	00111B
	DB	00000B

cgtbl0D	DB	11100B		; CR
	DB	10000B
	DB	10111B
	DB	11101B
	DB	00111B
	DB	00110B
	DB	00101B
	DB	00000B

cgtbl0E	DB	11000B		; SO
	DB	10000B
	DB	01000B
	DB	11111B
	DB	00101B
	DB	00101B
	DB	00111B
	DB	00000B

cgtbl0F	DB	11000B		; SI
	DB	10000B
	DB	01000B
	DB	11111B
	DB	00010B
	DB	00010B
	DB	00111B
	DB	00000B

cgtbl10	DB	11000B		; DE
	DB	10100B
	DB	10111B
	DB	11010B
	DB	00011B
	DB	00010B
	DB	00011B
	DB	00000B

cgtbl11	DB	11000B		; D1
	DB	10100B
	DB	10111B
	DB	11001B
	DB	00001B
	DB	00001B
	DB	00001B
	DB	00000B

cgtbl12	DB	11000B		; D2
	DB	10100B
	DB	10111B
	DB	11001B
	DB	00001B
	DB	00010B
	DB	00011B
	DB	00000B

cgtbl13	DB	11000B		; D3
	DB	10100B
	DB	10111B
	DB	11001B
	DB	00011B
	DB	00001B
	DB	00011B
	DB	00000B

cgtbl14	DB	11000B		; D4
	DB	10100B
	DB	10100B
	DB	11000B
	DB	00101B
	DB	00111B
	DB	00001B
	DB	00000B

cgtbl15	DB	11001B		; NK
	DB	10101B
	DB	10011B
	DB	00000B
	DB	00101B
	DB	00110B
	DB	00101B
	DB	00000B

cgtbl16	DB	11000B		; SN
	DB	10000B
	DB	01000B
	DB	11000B
	DB	11001B
	DB	10101B
	DB	10011B
	DB	00000B

cgtbl17	DB	11000B		; EB(Eb)
	DB	10000B
	DB	11100B
	DB	10100B
	DB	11111B
	DB	00101B
	DB	00110B
	DB	00000B

cgtbl18	DB	11100B		; CN
	DB	10000B
	DB	10000B
	DB	11100B
	DB	11001B
	DB	10101B
	DB	10011B
	DB	00000B

cgtbl19	DB	11000B		; EM
	DB	10000B
	DB	11000B
	DB	10000B
	DB	11011B
	DB	10101B
	DB	10001B
	DB	00000B

cgtbl1A	DB	11000B		; SB(Sb)
	DB	10000B
	DB	01100B
	DB	11100B
	DB	00111B
	DB	00101B
	DB	00110B
	DB	00000B

cgtbl1B	DB	11000B		; EC
	DB	10000B
	DB	11000B
	DB	10111B
	DB	11100B
	DB	00100B
	DB	00111B
	DB	00000B

cgtbl1C	DB	00000B		; ->
	DB	00100B
	DB	00010B
	DB	11111B
	DB	00010B
	DB	00100B
	DB	00000B
	DB	00000B

cgtbl1D	DB	00000B		; <-
	DB	00100B
	DB	01000B
	DB	11111B
	DB	01000B
	DB	00100B
	DB	00000B
	DB	00000B

cgtbl1E	DB	00100B		; ^
	DB	01110B
	DB	10101B
	DB	00100B
	DB	00100B
	DB	00100B
	DB	00100B
	DB	00000B

cgtbl1F	DB	00100B		; v
	DB	00100B
	DB	00100B
	DB	00100B
	DB	10101B
	DB	01110B
	DB	00100B
	DB	00000B



; ********************************
; ******                    ******
; ******    Main Program    ******
; ******                    ******
; ********************************

	ORG	300H

main:
	LD	A,00000001B	; Int OK
	OUT	(sioac),A
	LD	A,(memsw1)
	BIT	2,A
	JR	NZ,main0H
	LD	A,00010100B
	JR	main0I
main0H:
	LD	A,00010101B
main0I:
	OUT	(sioac),A

	LD	IX,pnt84
	EXX
	BIT	6,E
	EXX
	JR	NZ,main0M
	JR	main10
main0M:
	EXX
	RES	6,E
	EXX
	IN	A,(sioad)
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,main0Z
	RES	7,L
	CP	00010000B
	JR	Z,main0Z
	RES	6,L
	CP	00100000B
	JR	Z,main0Z
	RES	5,L
main0Z:
	LD	A,L
	CP	cl
	JR	Z,main10
	JP	sio_start



; --------------- Main Loop ---------------

main10:
	LD	IX,pnt84
	EI
	NOP
main13:	DI

	EXX
	LD	A,E
	EXX
	BIT	6,A
	JP	NZ,sioin
main19:

	LD	A,5		; DTR,RTS On
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001010B
	OUT	(sioac),A

	LD	IX,pnt01
	EI
	NOP
main11:	DI

	LD	A,(memsw3)
	BIT	0,A
	JP	NZ,keyin

	EXX
	RES	4,E
	RES	5,E
	EXX
main12:

	JR	main10


; ///// Return Address Table /////

pnt01	DW	main11
pnt84	DW	main13



; ************************************
; ******    Key Input Module    ******
; ************************************

keyin:	EXX			; Key Mask ??
	LD	A,E
	EXX
	AND	00110000B
	CP	00010000B
	JR	Z,keyi0A

	LD	IY,pnt60	; First Read
	JP	scan
keyi01:	BIT	0,E
	JR	NZ,keyi10

keyi08:	EXX			; Flag Reset
	RES	4,E
	RES	5,E
	EXX

	LD	A,(memsw3)
	BIT	3,A
	JR	NZ,keyi02
	JR	keyi03
keyi02:
	EXX
	RES	2,E
	EXX
	LD	A,ctc_stop
	OUT	(ctc3),A
keyi03:

keyi09:
keyi0A:
	LD	A,5		; DTR,RTS On
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001010B
	OUT	(sioac),A

	JP	main12


keyi10:	LD	D,A

	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00100000B
	JR	Z,keyi09

	LD	A,5		; RTS = Hi
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	BC,500		; 3.6(ms) Wait
	LD	IX,pnt55
keyi11:	EI
	NOP
keyi12:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,keyi11

	LD	IY,pnt59	; Double Read
	JP	scan
keyi13:	BIT	0,E
	JR	NZ,keyi20
	JP	keyi08


keyi20:	CP	D		; Equal?
	JR	Z,keyi30
	JP	keyi08


keyi30:	EXX			; Check Flag
	LD	A,E
	EXX
	AND	00110000B
	CP	00100000B
	JP	Z,keyi39

keyi34:	EXX			; Flag Set
	SET	4,E
	SET	5,E
	EXX

	IN	A,(moderg)	; Shift In / Out ??
	BIT	5,A
	JR	NZ,keyi36
	JR	keyi37
keyi36:	LD	A,40H
	ADD	A,D
	LD	D,A
keyi37:	LD	E,D		; Key-No. -> ASCII-Code
	LD	D,0
	LD	HL,ktbl00
	ADD	HL,DE

	IN	A,(moderg)	; Function ??
	BIT	6,A
	JP	NZ,func

	LD	A,(memsw3)	; Repeat On ??
	BIT	3,A
	JP	NZ,keyi40

keyi3D:
	LD	A,(memsw1)	; 1ward Transmit ??
	BIT	4,A
	JP	NZ,keyi3A

keyi3B:
	LD	A,(memsw1)
	BIT	4,A
	JR	Z,keyi3G

	LD	A,(HL)
	CP	dle
	JR	NZ,keyi3H
	LD	A,cr
keyi3H:
	JR	keyi3I
keyi3G:
	LD	A,(HL)
keyi3I:

	CP	null
	JR	NC,keyi31
	JR	keyi32
keyi31:	CP	us+1
	JR	C,keyi33
keyi32:	JP	dsp
keyi33:	JP	cnt

keyi35:	EXX			; Flag Reset
	RES	4,E
	SET	5,E
	EXX

keyi39:	JP	keyi09


keyi3A:
	LD	A,(HL)
	CP	so
	JP	Z,keyi3B
	CP	si
	JP	Z,keyi3B
	CP	d1
	JP	Z,keyi3B

keyi3F:
	JP	tx_one
keyi3C:
	LD	A,(memsw1)
	BIT	5,A
	JP	NZ,keyi3B
	JR	keyi35


keyi40:
	LD	A,(HL)
	CP	so
	JR	Z,keyi41
	CP	si
	JR	Z,keyi41
	CP	dle
	JR	Z,keyi41
	CP	d1
	JR	Z,keyi41
	CP	ec
	JR	Z,keyi41
	CP	cr
	JR	Z,keyi41
	CP	lf
	JR	Z,keyi41
	CP	ec
	JR	Z,keyi41

	LD	A,ctcw30
	OUT	(ctc3),A
	EXX
	BIT	2,E
	EXX
	JR	NZ,keyi4A
	JR	keyi4B
keyi4A:
	LD	A,(memsw3)
	BIT	4,A
	JR	Z,keyi48
keyi4B:
	LD	A,(rep_time1)
	JR	keyi49
keyi48:
	LD	A,(rep_time0)
keyi49:
	OUT	(ctc3),A
	EXX
	SET	2,E
	EXX
	JR	keyi47
keyi41:
	LD	A,ctc_stop
	OUT	(ctc3),A
	EXX
	RES	2,E
	EXX
keyi47:
	JP	keyi3D



; ///// Return Address Table /////

pnt60	DW	keyi01
pnt55	DW	keyi12
pnt59	DW	keyi13



; ============================
; ====    Key Scan Sub    ====
; ============================

scan:	IN	A,(pioad)	; Ext.Out
	LD	L,A
	LD	A,(memsw3)
	BIT	2,A
	JR	Z,scan01
	BIT	1,A
	JR	Z,scan02
	LD	A,00000000B
	JR	scan03
scan01:	LD	A,11110000B
	JR	scan03
scan02:	LD	A,11000000B
scan03:	CPL
	LD	H,A
	CPL
	AND	L
	LD	L,A

	EXX
	LD	C,11111110B
	LD	B,0
	EXX

	LD	A,(memsw3)	; Matrix8x?
	AND	00000110B
	INC	A
	INC	A
	LD	C,A

	LD	E,0

scan04:	LD	IX,pnt85
	EI
	NOP
scan0B:	DI

scan0C:	LD	A,11001111B
	OUT	(pioac),A

	EXX
	LD	A,C
	EXX
	AND	H
	OUT	(pioac),A

	EXX
	LD	A,C
	EXX
	AND	H
	OR	L
	OUT	(pioad),A

	EXX
	EX	AF,AF'
	LD	A,C
	EX	AF,AF'
	LD	A,C
	CPL
	LD	C,A
	IN	A,(pioad)
	AND	C
	EX	AF,AF'
	LD	C,A
	EX	AF,AF'
	EXX
	OR	A
	JR	NZ,scan0C

	IN	A,(piobd)	; Input
	CPL

	LD	B,0

scan05:	BIT	0,A		; Check
	JP	NZ,scan10
scan06:	SRL	A
	INC	B
	EX	AF,AF'
	LD	A,8
	CP	B
	JR	Z,scan0A
	EX	AF,AF'
	JR	scan05

scan0A:	EX	AF,AF'

	EXX
	RLC	C
	EXX
	INC	E
	DEC	C
	JP	NZ,scan04

	EXX
	LD	A,B
	EXX
	BIT	7,A
	JR	NZ,scan08
scan07:	LD	E,00
	JR	scan09
scan08:	RES	7,A
	LD	B,A
	LD	E,01

scan09:	LD	A,11001111B
	OUT	(pioac),A
	LD	A,H
	OUT	(pioac),A
	LD	A,L
	OUT	(pioad),A

	LD	A,B

	LD	SP,IY
	RET


scan10:	EX	AF,AF'
	EXX
	LD	A,B
	EXX
	BIT	7,A
	JR	NZ,scan11

	LD	A,E		; Key-No.
	SLA	A
	SLA	A
	SLA	A
	OR	B
	EXX
	LD	B,A
	SET	7,B
	EXX

	EX	AF,AF'
	JP	scan06

scan11:	EX	AF,AF'
	JP	scan07


; ///// Return Address Table /////

pnt85	DW	scan0B



; =====================================
; ====    Transmit 1_Ward Sub    ======
; =====================================

tx_one:
	LD	A,(HL)
	CP	dle
	JR	NZ,txon02
	LD	A,cr
txon02:
	EXX
	LD	C,1
	EXX
	LD	IY,pnt41
	JP	txout
txon01:
	LD	A,(memsw1)
	BIT	3,A
	JR	Z,txon09
	LD	A,(HL)
	CP	dle
	JR	NZ,txon03
	LD	A,cr
txon03:
	CP	cr
	JR	NZ,txon09
	LD	A,lf
	EXX
	LD	C,1
	EXX
	LD	IY,pnt42
	JP	txout
txon09:
	JP	keyi3C


; ///// Return Address Table /////

pnt41	DW	txon01
pnt42	DW	txon09



; ================================
; ====    Function Key Sub    ====
; ================================

func:	LD	A,(HL)
	CP	'0'
	JR	NC,func01
	JR	func02
func01:	CP	'9'+1
	JR	C,func10

func02:	IN	A,(moderg)
	RES	6,A
	OUT	(moderg),A
	BIT	7,A
	JR	NZ,func03

	LD	A,wdtnot
	OUT	(contrg),A
	JR	func04

func03:	LD	A,wdtpls
	OUT	(contrg),A

func04:
	LD	A,5		; RTS On
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001010B
	OUT	(sioac),A

	JP	keyi35


func10:	LD	C,A
	SUB	30H
	LD	E,A
	LD	D,0
	SLA	E
	RL	D
	SLA	E
	RL	D
	SLA	E
	RL	D
	SLA	E
	RL	D
	LD	HL,func_text0
	ADD	HL,DE
	LD	A,(HL)
	LD	B,A
	OR	A
	JP	Z,func02

	LD	A,H
	EXX
	LD	B,A
	EXX
	LD	A,L
	EXX
	LD	C,A
	EXX

	INC	HL

func11:	LD	DE,0

func12:	LD	IX,pnt93
	EI
	NOP
func13:	DI
	DEC	DE
	LD	A,D
	OR	E
	JR	Z,func14
	IN	A,(sioac)
	AND	04H
	JR	Z,func12
	LD	A,(HL)
	OUT	(sioad),A
	INC	HL
	DJNZ	func11

func14:
	LD	A,(memsw2)
	BIT	4,A
	JP	NZ,func20
func19:
	JP	func02


func20:
	EXX
	LD	A,B
	EXX
	LD	D,A
	EXX
	LD	A,C
	EXX
	LD	E,A

	LD	A,(DE)
	LD	C,A

	INC	DE

func21:
	LD	A,(DE)
	CP	null
	JR	NC,func22
	JR	func23
func22:	CP	us+1
	JR	C,func24

func23:
	JP	dsp

func24:
	CP	cr
	JP	Z,return

func25:
	INC	DE
	DEC	C
	JP	NZ,func21

	JP	func19


; ///// Return Address Table /////

pnt93	DW	func13



; *******************************************
; ******    SIO-A Data Input Module    ******
; *******************************************

sioin:	EXX
	RES	6,E
	EXX

sioi01:
	IN	A,(sioac)	; RS-232C In ??
	AND	1
	JR	NZ,sioi10
sioi09:	JP	main19


sioi10:	IN	A,(sioad)	; RS-232C Read
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,sioi1Z
	RES	7,L
	CP	00010000B
	JR	Z,sioi1Z
	RES	6,L
	CP	00100000B
	JR	Z,sioi1Z
	RES	5,L
sioi1Z:
	LD	A,L

sio_start:			; <--------------- Start

	EX	AF,AF'		; Function Key ??
	IN	A,(moderg)
	BIT	6,A
	JP	NZ,sioi20
	LD	A,(memsw3)
	BIT	0,A
	JP	Z,sioi14
	EX	AF,AF'

	JP	keyoff		; Key Mask Off
sioi12:	JP	keyon		;          On
sioi13:	CP	ec		; ESC ??
	JP	Z,esc
	CP	null		; Controll Code ??
	JP	C,sioi11
	CP	us+1
	JP	C,cnt
sioi11:	JP	dsp		; Display
sioi19:	JP	sioi01


sioi14:	EX	AF,AF'
	JP	sioi12


sioi20:	EX	AF,AF'
	JP	sioi19



; **************************************
; ******    Key Mask On Module    ******
; **************************************

keyon:	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
	CP	ex
	JP	Z,kon10
kon09:	JP	sioi13


kon10:
	EX	AF,AF'
	LD	A,(memsw3)
	BIT	3,A
	JR	NZ,kon11
	EX	AF,AF'
	EXX
	RES	4,E
	SET	5,E
	EXX
	JR	kon14
kon11:
	EX	AF,AF'
	EXX
	BIT	2,E
	JR	NZ,kon12
	RES	4,E
	RES	5,E
	JR	kon13
kon12:
	RES	4,E
	SET	5,E
kon13:
	EXX
kon14:
	JP	kon09



; ***************************************
; ******    Key Mask Off Module    ******
; ***************************************

keyoff:	CP	sh
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	enq
	JP	Z,koff10
	CP	ec
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	sx
	JP	Z,koff10
	CP	sx
	JP	Z,koff10

koff09:	JP	sioi12


koff10:	EXX
	SET	4,E
	RES	5,E
	EXX
	JP	koff09



; **************************************
; ******    LCD Display Module    ******
; **************************************

dsp:	EX	AF,AF'

	EXX
	LD	A,L
	EXX
	CP	gyou0
	JP	NC,dsp01

dsp00:	LD	A,(lcdbfg)	; Display
	BIT	7,A
	JR	NZ,dsp00
	EX	AF,AF'
	LD	(lcdwd),A
	JP	dsp02

dsp01:	LD	A,(lcdbfg2)	; Display
	BIT	7,A
	JR	NZ,dsp01
	EX	AF,AF'
	LD	(lcdwd2),A

dsp02:	EXX			; Carsol+1
	LD	A,H
	INC	A
	CP	keta
	JP	NC,dsp10
	LD	H,A
	EXX

dsp09:	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JP	Z,dsp0A
	JP	sioi19


dsp0A:
	IN	A,(moderg)
	BIT	6,A
	JP	NZ,func25
	JP	keyi35


dsp10:	XOR	A
	LD	H,A
	INC	L

	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,dsp12
	LD	A,gyou0-1
	JR	dsp13
dsp12:	LD	A,gyou1-1

dsp13:	CP	L
	JP	C,dsp20
	EXX

dsp11:	LD	IY,pnt74
	JP	carset

dsp19:	JP	dsp09


dsp20:	LD	L,A
	LD	A,(memsw2)
	BIT	2,A
	JR	Z,dsp2A
	EXX
	IN	A,(moderg)
	BIT	6,A
	JR	NZ,dsp2B
	JP	roll		; Scroll
dsp29:	JP	dsp11

dsp2A:	LD	H,0
	LD	L,0
	EXX
	JR	dsp29

dsp2B:
	LD	IY,pntA3
	JP	rollup
dsp2C:	JP	dsp29


; ///// Return Address Table /////

pnt74	DW	dsp19
pntA3	DW	dsp2C



; ==========================
; ====    Scroll Sub    ====
; ==========================

roll:
	LD	A,5		; RTS = Hi
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	IY,pnt46
	JP	rollup

roll06:
roll09:	JP	dsp29


; ///// Return Address Table /////

pnt46	DW	roll06



; ---------------------------
; ----    Roll-Up Sub    ----
; ---------------------------

rollup:
	LD	A,5		; RTS = Hi
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	IX,pnt52
	LD	H,lcduhm OR 80H
	LD	L,lcddhm OR 80H
	LD	B,keta

roup00:	EI
	NOP
roup07:	DI
	LD	A,(lcdbfg)	; Under Line -> Over Line
	BIT	7,A
	JR	NZ,roup00
	LD	A,L
	LD	(lcdir),A

roup01:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup01
	LD	A,(lcdrd)

	EX	AF,AF'
roup02:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup02
	LD	A,H
	LD	(lcdir),A

roup03:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup03
	EX	AF,AF'
	LD	(lcdwd),A

	INC	H
	INC	L
	DJNZ	roup00

	LD	A,(memsw0)
	BIT	1,A
	JP	NZ,roup10

roup04:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup04
	LD	A,lcddhm OR 80H
	LD	(lcdir),A

	LD	IX,pnt53
	LD	B,keta

roup05:	EI
	NOP
roup08:	DI
	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup05
	LD	A,spc
	LD	(lcdwd),A
	DJNZ	roup05

roup06:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup06
	LD	A,lcddhm OR 80H
	LD	(lcdir),A

roup09:	LD	SP,IY
	RET


roup10:	LD	IX,pnt62
	LD	H,lcddhm OR 80H
	LD	L,lcduhm2 OR 80H
	LD	B,keta

roup11:	EI
	NOP
roup12:	DI
	LD	A,(lcdbfg2)	; Under Line -> Over Line
	BIT	7,A
	JR	NZ,roup11
	LD	A,L
	LD	(lcdir2),A

roup13:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup13
	LD	A,(lcdrd2)

	EX	AF,AF'
roup14:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup14
	LD	A,H
	LD	(lcdir),A

roup15:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,roup15
	EX	AF,AF'
	LD	(lcdwd),A

	INC	H
	INC	L
	DJNZ	roup11

roup20:	LD	IX,pnt63
	LD	H,lcduhm2 OR 80H
	LD	L,lcddhm2 OR 80H
	LD	B,keta

roup21:	EI
	NOP
roup22:	DI
	LD	A,(lcdbfg2)	; Under Line -> Over Line
	BIT	7,A
	JR	NZ,roup21
	LD	A,L
	LD	(lcdir2),A

roup23:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup23
	LD	A,(lcdrd2)

	EX	AF,AF'
roup24:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup24
	LD	A,H
	LD	(lcdir2),A

roup25:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup25
	EX	AF,AF'
	LD	(lcdwd2),A

	INC	H
	INC	L
	DJNZ	roup21

roup30:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup30
	LD	A,lcddhm2 OR 80H
	LD	(lcdir2),A

	LD	IX,pnt64
	LD	B,keta

roup31:	EI
	NOP
roup32:	DI
	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup31
	LD	A,spc
	LD	(lcdwd2),A
	DJNZ	roup31

roup33:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,roup33
	LD	A,lcddhm2 OR 80H
	LD	(lcdir2),A

	JP	roup09


; ///// Return Address Table /////

pnt52	DW	roup07
pnt53	DW	roup08
pnt62	DW	roup12
pnt63	DW	roup22
pnt64	DW	roup32



; ==============================
; ====    Carsol Set Sub    ====
; ==============================

carset:	EXX
	LD	A,L
	CP	0
	JP	Z,cars10
	CP	1
	JP	Z,cars11
	CP	2
	JP	Z,cars20
	CP	3
	JP	Z,cars21
cars09:	EXX
	JP	cardsp


cars10:	LD	B,lcduhm OR 80H	; Upper Module
	JR	cars12
cars11:	LD	B,lcddhm OR 80H
cars12:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cars12
	LD	A,B
	ADD	A,H
	LD	(lcdir),A
	JP	cars09


cars20:				; Lower Module
	LD	B,lcduhm2 OR 80H
	JR	cars22
cars21:	LD	B,lcddhm2 OR 80H
cars22:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cars22
	LD	A,B
	ADD	A,H
	LD	(lcdir2),A
	JP	cars09



; ==================================
; ====    Carsol Display Sub    ====
; ==================================

cardsp:	EXX
	BIT	3,E
	JP	NZ,card20

	LD	A,L
	CP	gyou0
	JP	NC,card10

card09:	EXX
	LD	SP,IY
	RET


card10:	LD	A,(lcdbfg)	; Upper Module -> Lower Module
	BIT	7,A
	JR	NZ,card10
	LD	A,lcddon
	LD	(lcdir),A

card11:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,card11
	LD	A,E
	AND	00000011B
	OR	lcddon
	LD	(lcdir2),A

	SET	3,E

	JP	card09


card20:	LD	A,L
	CP	gyou0
	JP	C,card30
	JP	card09


card30:	LD	A,(lcdbfg2)	; Lower Module -> Upper Module
	BIT	7,A
	JR	NZ,card30
	LD	A,lcddon
	LD	(lcdir2),A

card31:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,card31
	LD	A,E
	AND	00000011B
	OR	lcddon
	LD	(lcdir),A

	RES	3,E

	JP	card09



; =============================================
; ====    Carsol Blink or Under_bar Sub    ====
; =============================================

car_b:
	EXX
	LD	A,E
	EXX
	LD	D,A
	AND	00000011B
	JP	Z,carb09

carb00:
	EXX
	LD	A,E
	EXX
	LD	D,A

	IN	A,(moderg)
	BIT	3,A
	JR	Z,carb02
	SET	0,D
	RES	1,D
	JR	carb03
carb02:
	RES	0,D
	SET	1,D
carb03:
	LD	A,D
	EXX
	LD	E,A
	LD	A,L
	EXX

	CP	gyou0
	JP	NC,carb10

carb01:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,carb01
	LD	A,D
	AND	00000011B
	OR	lcddon
	LD	(lcdir),A

carb09:	LD	SP,IY
	RET


carb10:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,carb10
	LD	A,D
	AND	00000011B
	OR	lcddon
	LD	(lcdir2),A
	JP	carb09



; ==============================================
; ====    Carsol Blink and Under_bar Sub    ====
; ==============================================

car_c:
	EXX
	LD	A,E
	EXX
	LD	D,A
	AND	00000011B
	JP	Z,carc09

carc00:
	EXX
	LD	A,E
	EXX
	LD	D,A

	SET	0,D
	SET	1,D
	LD	A,D
	EXX
	LD	E,A
	LD	A,L
	EXX

	CP	gyou0
	JP	NC,carc10

carc01:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,carc01
	LD	A,D
	AND	00000011B
	OR	lcddon
	LD	(lcdir),A

carc09:	LD	SP,IY
	RET


carc10:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,carc10
	LD	A,D
	AND	00000011B
	OR	lcddon
	LD	(lcdir2),A
	JP	carc09



; ****************************************
; ******    Controll Code Module    ******
; ****************************************

cnt:	JP	cntdsp

cnt00:	CP	bl		; Bell
	JP	Z,bell
	CP	bs		; Back Space
	JP	Z,back
	CP	lf		; Line Feed
	JP	Z,feed
	CP	hm		; Home Position
	JP	Z,home
	CP	cl		; CLS
	JP	Z,cls
	CP	cr		; Carriage Return
	JP	Z,return
	CP	so		; Shift Out
	JP	Z,sft_out
	CP	si		; Shift In
	JP	Z,sft_in
	CP	dle		; Send
	JP	Z,send
	CP	d1		; Func
	JP	Z,func_x
	CP	fs		; Carsol Right
	JP	Z,right
	CP	gs		;        Left
	JP	Z,left
	CP	rs		;        Up
	JP	Z,up
	CP	us		;        Down
	JP	Z,down

	JP	cntmov

cnt09:	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JP	Z,cnt0A
	JP	sioi19


cnt0A:
	IN	A,(moderg)
	BIT	6,A
	JP	NZ,func25
	JP	keyi35



; ========================================
; ====    Display Control-Code Sub    ====
; ========================================

cntdsp:	LD	C,A
	LD	A,(memsw2)
	BIT	1,A
	JP	NZ,cntd10
	LD	A,C
cntd09:	JP	cnt00


cntd10:	LD	A,C

	LD	IY,pnt19
	JP	cntchk

cntd11:	EX	AF,AF'

	EXX
	LD	A,L
	EXX
	CP	gyou0
	JP	NC,cntd20

cntd12:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cntd12
	EX	AF,AF'
	LD	(lcdwd),A

cntd13:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cntd13
	LD	A,lcdcl
	LD	(lcdir),A

cntd14:	LD	A,C

	JP	cntd09


cntd20:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cntd20
	EX	AF,AF'
	LD	(lcdwd2),A

cntd21:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cntd21
	LD	A,lcdcl
	LD	(lcdir2),A

	JP	cntd14


; ///// Return Address Table /////

pnt19	DW	cntd11



; ================================================
; ====    Move Carsol for Control-Code Sub    ====
; ================================================

cntmov:	LD	A,(memsw2)
	BIT	1,A
	JP	NZ,cntm00
cntm09:	JP	cnt09

cntm00:	EXX
	INC	H
	LD	A,H
	CP	keta
	JP	NC,cntm10

cntm01:	EXX
	LD	IY,pnt77
	JP	carset
cntm02:	JP	cntm09


cntm10:	LD	H,0
	INC	L
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,cntm11
	LD	A,gyou0-1
	JR	cntm12
cntm11:	LD	A,gyou1-1
cntm12:	CP	L
	JP	C,cntm20
	JP	cntm01


cntm20:	LD	L,A
	LD	A,(memsw2)
	BIT	2,A
	JP	Z,cntm2A
	EXX

	LD	A,5
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	IY,pnt49
	JP	rollup

cntm21:	LD	A,5
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001010B
	OUT	(sioac),A

cntm29:	JP	cntm09

cntm2A:	LD	H,0
	LD	L,0
	EXX
	JR	cntm29


; ///// Return Address Table /////

pnt49	DW	cntm21
pnt77	DW	cntm02



; ======================================
; ====    Control-Code Check Sub    ====
; ======================================

cntchk:	LD	E,A
	LD	HL,cntbl00
	ADD	A,L
	LD	L,A
	LD	A,0
	ADC	A,H
	LD	H,A
	LD	A,(HL)
	CP	07
	JP	Z,cgset
cntc01:	LD	SP,IY
	RET



; ===================================
; ====    CG-RAM Data Set Sub    ====
; ===================================

cgset:
	LD	A,5
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	A,10
cg06:	DEC	A
	JR	NZ,cg06

	EXX
	LD	A,L
	CP	gyou0
	JR	NC,cg07
	LD	A,(lcdbfg)
	AND	01111111B
	JR	cg08
cg07:	LD	A,(lcdbfg2)
	AND	01111111B
cg08:	LD	B,A
	EXX

	LD	A,E
	LD	HL,cgtbl00
	OR	A
	JR	Z,cg02
cg01:	LD	A,8
	ADD	A,L
	LD	L,A
	LD	A,0
	ADC	A,H
	DEC	E
	JR	NZ,cg01

cg02:	EXX
	LD	A,L
	EXX
	CP	gyou0
	JP	NC,cg10

cg03:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cg03
	LD	A,01111000B
	LD	(lcdir),A

	LD	E,8
cg04:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cg04
	LD	A,(HL)
	LD	(lcdwd),A
	INC	HL
	DEC	E
	JR	NZ,cg04

cg05:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cg05
	EXX
	LD	A,B
	EXX
	OR	80H
	LD	(lcdir),A

cg09:
	LD	A,7

	JP	cntc01


cg10:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cg10
	LD	A,01111000B
	LD	(lcdir2),A

	LD	E,8
cg11:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cg11
	LD	A,(HL)
	LD	(lcdwd2),A
	INC	HL
	DEC	E
	JR	NZ,cg11

cg12:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cg12
	EXX
	LD	A,B
	EXX
	OR	80H
	LD	(lcdir2),A

	JP	cg09



; ========================
; ====    Bell Sub    ====
; ========================

bell:
	LD	A,(memsw3)
	BIT	3,A
	JR	NZ,bell09

	EXX
	LD	A,E
	EXX
	BIT	2,A
	JR	NZ,bell10

	LD	A,ctcw32		; Bell On
	OUT	(ctc3),A
	LD	A,const32
	OUT	(ctc3),A
	EXX
	SET	2,E
	EXX

bell09:	JP	cnt09


bell10:	LD	A,ctc_stop		; Bell Off
	OUT	(ctc3),A
	EXX
	RES	2,E
	EXX
	JR	bell09



; ==============================
; ====    Back Space Sub    ====
; ==============================

back:
	LD	A,5		; RTS = Hi
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	EXX
	LD	A,L
	EXX
	LD	E,A
	EXX
	LD	A,H
	EXX
	OR	A		; Most Left ??
	JP	Z,back09

	LD	D,A
	BIT	0,E		; Most Over ??
	JR	Z,back00
	LD	A,lcddhm OR 80H
	JR	back01
back00:	LD	A,lcduhm OR 80H
back01:	ADD	A,D		; LCD Read Address
	LD	H,A
	DEC	A		;     Write Address
	LD	L,A
	LD	A,keta		; Loop Cnt
	SUB	D
	LD	B,A

	LD	A,E
	CP	gyou0
	JP	NC,back10

	LD	IX,pnt54

back02:	EI
	NOP
back0A:	DI
	LD	A,(lcdbfg)	; LCD Read Data
	BIT	7,A
	JR	NZ,back02
	LD	A,H
	OR	80H
	LD	(lcdir),A

back03:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,back03
	LD	A,(lcdrd)

	EX	AF,AF'
back04:	LD	A,(lcdbfg)	; LCD Write Data
	BIT	7,A
	JR	NZ,back04
	LD	A,L
	OR	80H
	LD	(lcdir),A

back05:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,back05
	EX	AF,AF'
	LD	(lcdwd),A

	INC	H
	INC	L
	DJNZ	back02

back06:	LD	A,(lcdbfg)	; Space
	BIT	7,A
	JR	NZ,back06
	LD	A,spc
	LD	(lcdwd),A

back07:	EXX			; Carsol Set
	DEC	H
	EXX
	LD	IY,pnt70
	JP	carset

back09:
	JP	cnt09


back10:	LD	IX,pnt65

back11:	EI
	NOP
back12:	DI
	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,back11
	LD	A,H
	LD	(lcdir2),A

back13:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,back13
	LD	A,(lcdrd2)

	EX	AF,AF'
back14:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,back14
	LD	A,L
	LD	(lcdir2),A

back15:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,back15
	EX	AF,AF'
	LD	(lcdwd2),A

	INC	H
	INC	L
	DJNZ	back11

back16:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,back16
	LD	A,spc
	LD	(lcdwd2),A

	JP	back07


; ///// Return Address Table /////

pnt54	DW	back0A
pnt65	DW	back12
pnt70	DW	back09



; =============================
; ====    Line Feed Sub    ====
; =============================

feed:	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00010000B
	JP	Z,feed09

	LD	A,5		; RTS = Hi
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	EXX			; Scroll ??
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,feed03
	LD	A,gyou0-1
	JR	feed04
feed03:	LD	A,gyou1-1
feed04:	CP	L
	JP	Z,feed10

	LD	H,0
	INC	L
	EXX

feed01:	LD	IY,pnt71	; Carsol Set
	JP	carset

feed02:
	EXX			; from Keyin ??
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,feed0Z
	CP	00100000B
	JR	Z,feed0Z

feed09:	EXX
	RES	4,E
	SET	5,E
	EXX

feed0Z:	JP	cnt09


feed10:	LD	H,0
	EXX
	LD	IY,pnt47
	JP	rollup
feed19:	JP	feed01


; ///// Return Address Table /////

pnt47	DW	feed19
pnt71	DW	feed02



; =================================
; ====    Home Position Sub    ====
; =================================

home:	EXX
	LD	H,0
	LD	L,0
	EXX

home00:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,home00
	LD	A,lcdhm
	LD	(lcdir),A

home01:	LD	IY,pnt76
	JP	cardsp

home09:	JP	cnt09


; ///// Return Address Table /////

pnt76	DW	home09


; ==============================
; ====    Text Clear Sub    ====
; ==============================

cls:	EXX
	LD	H,0
	LD	L,0
	EXX

cls00:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cls00
	LD	A,lcdcls
	LD	(lcdir),A

	LD	A,(memsw0)
	BIT	1,A
	JP	NZ,cls10

cls01:	LD	IY,pnt72
	JP	cardsp

cls09:	JP	cnt09


cls10:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cls10
	LD	A,lcdcls
	LD	(lcdir2),A
	JP	cls01


; ///// Return Address Table /////

pnt72	DW	cls09



; ===================================
; ====    Carriage Return Sub    ====
; ===================================

return:
	LD	A,(memsw1)
	BIT	4,A
	JP	NZ,ret00

	EXX			; from Keyin ??
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JP	Z,ret10

ret00:	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00010000B
	JP	Z,ret01

	EXX
	LD	H,0
	EXX

	LD	IY,pnt73
	JP	carset

ret01:	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JP	Z,feed
;	CP	00100000B
;	JP	Z,feed

	LD	A,(memsw1)
	BIT	1,A
	JP	NZ,feed

	EXX
	RES	4,E
	SET	5,E
	EXX

	JP	cnt09


ret10:
	IN	A,(moderg)
	BIT	6,A
	JP	NZ,ret1A

	EXX			; 1_Line Transmit
	LD	A,L
	EXX
	CP	gyou0
	JP	NC,ret20

ret11:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,ret11
	EXX
	LD	A,L
	EXX
	CP	0
	JR	NZ,ret12
	LD	A,lcduhm OR 80H
	JR	ret13
ret12:	LD	A,lcddhm OR 80H
ret13:	LD	(lcdir),A

	EXX
	LD	A,H
	EXX
	CP	0
	JP	Z,ret17
	LD	B,A

ret14:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,ret14
	LD	A,(lcdrd)
	LD	D,A
	LD	HL,0

ret15:	LD	IX,pnt98
	EI
	NOP
ret16:	DI
	DEC	HL
	LD	A,H
	OR	L
	JP	Z,ret19
	IN	A,(sioac)
	AND	04H
	JR	Z,ret15

	LD	A,D
	OUT	(sioad),A
	DJNZ	ret14

ret17:	LD	A,cr
	EXX
	LD	C,1
	EXX
	LD	IY,pntA0
	JP	txout

ret18:	LD	A,(memsw1)
	BIT	3,A
	JR	Z,ret19
	LD	A,lf
	EXX
	LD	C,1
	EXX
	LD	IY,pntA1
	JP	txout

ret19:	LD	IY,pntA2
	JP	carset

ret1A:	JP	ret00


ret20:
ret21:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,ret21
	EXX
	LD	A,L
	EXX
	CP	gyou0
	JR	NZ,ret22
	LD	A,lcduhm2 OR 80H
	JR	ret23
ret22:	LD	A,lcddhm2 OR 80H
ret23:	LD	(lcdir2),A

	EXX
	LD	A,H
	EXX
	CP	0
	JP	Z,ret27
	LD	B,A

ret24:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,ret24
	LD	A,(lcdrd2)
	LD	D,A
	LD	HL,0

ret25:	LD	IX,pnt99
	EI
	NOP
ret26:	DI
	DEC	HL
	LD	A,H
	OR	L
	JP	Z,ret29
	IN	A,(sioac)
	AND	04H
	JR	Z,ret25

	LD	A,D
	OUT	(sioad),A
	DJNZ	ret24

ret27:	JP	ret17

ret29:	JP	ret19


; ///// Return Address Table /////

pnt73	DW	ret01
pnt98	DW	ret16
pnt99	DW	ret26
pntA0	DW	ret18
pntA1	DW	ret19
pntA2	DW	ret1A



; =============================
; ====    Shift Out Sub    ====
; =============================

sft_out:
	IN	A,(moderg)
	RES	5,A
	OUT	(moderg),A
	BIT	7,A
	JR	NZ,sfou01
	LD	A,wdtnot
	OUT	(contrg),A
	JR	sfou02

sfou01:	LD	A,wdtpls
	OUT	(contrg),A

sfou02:	LD	IY,pnt80
	JP	car_b

sfou03:	JP	cnt09


; ///// Return Address Table /////

pnt80	DW	sfou03



; ============================
; ====    Shift In Sub    ====
; ============================

sft_in:
	IN	A,(moderg)
	SET	5,A
	OUT	(moderg),A
	BIT	7,A
	JR	NZ,sfou01
	LD	A,wdtnot
	OUT	(contrg),A
	JR	sfin02

sfin01:	LD	A,wdtpls
	OUT	(contrg),A

sfin02:	LD	IY,pnt81
	JP	car_c

sfin03:	JP	cnt09


; ///// Return Address Table /////

pnt81	DW	sfin03



; ================================
; ====    Send Display Sub    ====
; ================================

send:
	LD	SP,IY		; SX Transmit
	LD	HL,0
	ADD	HL,SP
	LD	A,sx
	EXX
	LD	C,1
	EXX
	LD	IY,pntAA
	JP	txout
send0E:
	LD	IY,0
	LD	D,H
	LD	E,L
	ADD	IY,DE

	LD	A,5		; RTS Off
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	A,10
send01:	DEC	A
	JR	NZ,send01

	LD	A,(lcdbfg)	; Get LCD Address
	AND	01111111B
	LD	E,A

send02:	LD	A,(lcdbfg)	; Set Address
	BIT	7,A
	JR	NZ,send02
	LD	A,lcduhm OR 80H
	LD	(lcdir),A

	LD	B,keta*gyou0	; Send Display

send03:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,send03
	LD	A,(lcdrd)
	LD	D,A

	LD	HL,0
send04:	LD	IX,pnt61
	EI
	NOP
send05:	DI
	DEC	HL
	LD	A,H
	OR	L
	JP	Z,send06
	IN	A,(sioac)
	AND	04
	JR	Z,send04
	LD	A,D
	OUT	(sioad),A

	DJNZ	send03

send06:	LD	A,(lcdbfg)	; Address Set
	BIT	7,A
	JR	NZ,send06
	LD	A,E
	OR	80H
	LD	(lcdir),A

	LD	A,(memsw0)
	BIT	1,A
	JP	NZ,send10

send09:	LD	SP,IY		; CR Transmit
	LD	HL,0
	ADD	HL,SP

	LD	A,cr
	EXX
	LD	C,1
	EXX
	LD	IY,pnt94
	JP	txout

send0B:	LD	A,(memsw1)	; LF Transmit
	BIT	3,A
	JP	Z,send0C

	LD	A,lf
	EXX
	LD	C,1
	EXX
	LD	IY,pnt96
	JP	txout

send0C:	LD	IY,0
	LD	D,H
	LD	E,L
	ADD	IY,DE

send0D:	LD	SP,IY		; from Escape Code ??
	POP	HL
	LD	SP,pnt86
	POP	DE
	LD	A,D
	CP	H
	JP	NZ,send0A
	LD	A,E
	CP	L
	JP	NZ,send0A
	LD	SP,IY
	RET

send0A:	JP	cnt09


send10:	LD	A,10
send11:	DEC	A
	JR	NZ,send11

	LD	A,(lcdbfg2)	; Get LCD Address
	AND	01111111B
	LD	E,A

send12:	LD	A,(lcdbfg2)	; Set Address
	BIT	7,A
	JR	NZ,send12
	LD	A,lcduhm2 OR 80H
	LD	(lcdir2),A

	LD	B,keta*gyou0	; Send Display

send13:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,send13
	LD	A,(lcdrd2)
	LD	D,A

	LD	HL,0
send14:	LD	IX,pnt78
	EI
	NOP
send15:	DI
	DEC	HL
	LD	A,H
	OR	L
	JP	Z,send16
	IN	A,(sioac)
	AND	04
	JR	Z,send14
	LD	A,D
	OUT	(sioad),A

	DJNZ	send13

send16:	LD	A,(lcdbfg2)	; Address Set
	BIT	7,A
	JR	NZ,send16
	LD	A,E
	OR	80H
	LD	(lcdir2),A

	JP	send09


; ///// Return Address Table /////

pnt61	DW	send05
pnt78	DW	send15
pnt94	DW	send0B
pnt96	DW	send0C
pntAA	DW	send0E



; ================================
; ====    Function Key Sub    ====
; ================================

func_x:
	EXX
	LD	A,E
	EXX
	AND	00110000B
	CP	00110000B
	JP	NZ,fu_x09

	LD	A,5		; RTS Off
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	IN	A,(moderg)
	SET	6,A
	OUT	(moderg),A
	BIT	7,A
	JR	NZ,fu_x01

	LD	A,wdtnot
	OUT	(contrg),A
	JR	fu_x08

fu_x01:	LD	A,wdtpls
	OUT	(contrg),A

fu_x08:	JP	keyi35

fu_x09:	JP	cnt09



; ===============================
; ====    Move Carsol Sub    ====
; ===============================

; <<<<< Right >>>>>

right:	EXX
	INC	H
	LD	A,H
	CP	keta
	JP	NC,righ10

righ00:	EXX
	LD	IY,pnt66
	JP	carset

righ09:	JP	cnt09


righ10:	LD	H,0
	INC	L
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,righ12
	LD	A,gyou0-1
	JR	righ13
righ12:	LD	A,gyou1-1
righ13:	CP	L
	JR	C,righ11
	JP	righ00

righ11:	LD	L,0
	JP	righ00


; ///// Return Address Table /////

pnt66	DW	righ09


; <<<<< Left >>>>>

left:	EXX
	DEC	H
	JP	M,left10

left00:	EXX
	LD	IY,pnt67
	JP	carset

left09:	JP	cnt09


left10:	LD	H,keta-1
	DEC	L
	JP	M,left11
	JP	left00

left11:	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,left12
	LD	A,gyou0-1
	JR	left13
left12:	LD	A,gyou1-1
left13:	LD	L,A
	JP	left00


; ///// Return Address Table /////

pnt67	DW	left09


; <<<<< Up >>>>>

up:	EXX
	DEC	L
	JP	M,up10

up00:	EXX
	LD	IY,pnt68
	JP	carset

up09:	JP	cnt09


up10:	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,up11
	LD	A,gyou0-1
	JR	up12
up11:	LD	A,gyou1-1
up12:	LD	L,A
	JP	up00


; ///// Return Address Table /////

pnt68	DW	up09


; <<<<< Down >>>>>

down:	EXX
	INC	L
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,down01
	LD	A,gyou0-1
	JR	down02
down01:	LD	A,gyou1-1
down02:	CP	L
	JP	C,down10

down00:	EXX
	LD	IY,pnt69
	JP	carset

down09:	JP	cnt09


down10:	LD	L,0
	JP	down00


; ///// Return Address Table /////

pnt69	DW	down09



; ***********************************
; ******    ESC Code Module    ******
; ***********************************

esc:	LD	HL,pnt04
	JP	escdsp

esc01:	LD	IX,pnt44
	LD	BC,0

esc00:	IN	A,(sioac)	; RS-232C Data In ??
	AND	01H
	JP	NZ,esc10
	EI
	NOP
esc02:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,esc00

esc09:	JP	sioi19


esc10:	IN	A,(sioad)	; Data In
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,esc1Z
	RES	7,L
	CP	00010000B
	JR	Z,esc1Z
	RES	6,L
	CP	00100000B
	JR	Z,esc1Z
	RES	5,L
esc1Z:
	LD	A,L

	LD	HL,pnt05
	JP	escdsp

esc14:	CP	'0'		; '0'-'9' or 'A'-'F' ??
	JP	NC,esc11
esc13:	CP	'/'		; Slush
	JP	Z,slush
esc19:	JP	esc09

esc11:	CP	'9'+1
	JP	C,ext
	CP	'A'
	JP	NC,esc12
	JP	esc13
esc12:	CP	'F'+1
	JP	C,ext
	JP	esc13


; ///// Return Address Table /////

pnt04	DW	esc01
pnt05	DW	esc14
pnt44	DW	esc02



; ===========================
; ====    Ext.Out Sub    ====
; ===========================

ext:	SUB	30H		; arc-ASCII
	CP	0AH
	JP	C,ext01
	SUB	7

ext01:	RLCA			; Ext.Out
	RLCA
	RLCA
	RLCA
	OUT	(pioad),A

	JP	esc19



; =================================
; ====    Slush Command Sub    ====
; =================================

slush:	LD	IX,pnt48
	LD	BC,0000

slus01:	IN	A,(sioac)
	AND	1
	JR	NZ,slus10
	EI
	NOP
slus02:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,slus01

slus09:	JP	esc19


slus10:	IN	A,(sioad)
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,slus1Z
	RES	7,L
	CP	00010000B
	JR	Z,slus1Z
	RES	6,L
	CP	00100000B
	JR	Z,slus1Z
	RES	5,L
slus1Z:
	LD	A,L

	LD	HL,pnt09
	JP	escdsp

slus11:	CP	'C'		; Carsol On/Off
	JP	Z,carsol
	CP	'L'		; Back Light On/Off
	JP	Z,light
	CP	'P'		; Position Set
	JP	Z,pset
	CP	'R'		; Send Display
	JP	Z,sendA
	CP	'S'		; Tx-out DIP.SW
	JP	Z,txdip
slus19:	JP	slus09


; ///// Return Address Table /////

pnt09	DW	slus11
pnt48	DW	slus02



; =====================================
; ====    Tx-out Dip-Switch Sub    ====
; =====================================

; <<<<< DIP-SW Read >>>>>

txdip:	IN	A,(pioad)
	AND	0F0H
	LD	C,A

	LD	A,(memsw3)
	BIT	0,A
	JR	Z,txdi01
	BIT	2,A
	JR	Z,txdi01
	BIT	1,A
	JR	Z,txdi03
	LD	B,11110000B
	JR	txdi04
txdi01:	LD	B,00000000B
	JR	txdi04
txdi03:	LD	B,11000000B

txdi04:	LD	A,11001111B	; DIP-Switch (4) -> L
	OUT	(pioac),A
	LD	A,00001110B
	OR	B
	OUT	(pioac),A
	XOR	A
	OR	C
	OUT	(pioad),A
	IN	A,(pioad)
	AND	00000001B
	OR	A
	JR	NZ,txdi04
	IN	A,(piobd)
	CPL
	LD	L,A

txdi05:	LD	A,11001111B	; DIP-Switch (3) -> H
	OUT	(pioac),A
	LD	A,00001101B
	OR	B
	OUT	(pioac),A
	XOR	A
	OR	C
	OUT	(pioad),A
	IN	A,(pioad)
	AND	00000010B
	OR	A
	JR	NZ,txdi05
	IN	A,(piobd)
	CPL
	LD	H,A

txdi06:	LD	A,11001111B	; DIP-Switch (2) -> E
	OUT	(pioac),A
	LD	A,00001011B
	OR	B
	OUT	(pioac),A
	XOR	A
	OR	C
	OUT	(pioad),A
	IN	A,(pioad)
	AND	00000100B
	OR	A
	JR	NZ,txdi06
	IN	A,(piobd)
	CPL
	LD	E,A

txdi07:	LD	A,11001111B	; DIP-Switch (1) -> D
	OUT	(pioac),A
	LD	A,00000111B
	OR	B
	OUT	(pioac),A
	XOR	A
	OR	C
	OUT	(pioad),A
	IN	A,(pioad)
	AND	00001000B
	OR	A
	JR	NZ,txdi07
	IN	A,(piobd)
	CPL
	LD	D,A

	LD	A,11001111B
	OUT	(pioac),A
	LD	A,00001111B
	OR	B
	OUT	(pioac),A
	LD	A,C
	OUT	(pioad),A

	LD	IX,pnt56
	EI
	NOP
txdi02:	DI



; <<<<< DIP-SW Tx-Out >>>>>

txdi10:	LD	IY,pnt25
	JP	status
txdi1I:	CP	0FFH
	JP	Z,txdi1Z

	LD	A,'#'		; #
	EXX
	LD	C,1
	EXX
	LD	IY,pnt06
	JP	txout

txdi11:	LD	A,D		; D
	LD	IY,pnt08
	JP	ascout

txdi13:	LD	A,E		; E
	LD	IY,pnt12
	JP	ascout

txdi17:	LD	A,H		; H
	LD	IY,pnt16
	JP	ascout

txdi1B:	LD	A,L		; L
	LD	IY,pnt20
	JP	ascout

txdi1F:	LD	A,cr		; CR
	EXX
	LD	C,1
	EXX
	LD	IY,pnt23
	JP	txout

txdi1J:	LD	A,(memsw1)	; LF
	BIT	3,A
	JP	Z,txdi1Z

	LD	A,lf
	EXX
	LD	C,1
	EXX
	LD	IY,pnt95
	JP	txout

txdi1Z:	JP	slus19


; ///// Return Address Table /////

pnt06	DW	txdi11
pnt08	DW	txdi13
pnt12	DW	txdi17
pnt16	DW	txdi1B
pnt20	DW	txdi1F
pnt23	DW	txdi1J
pnt25	DW	txdi1I

pnt56	DW	txdi02

pnt95	DW	txdi1Z


; =================================================
; ====    ASCII Convert & Tx-Out 2-Byte Sub    ====
; =================================================

; A -----> ASCII-Code(2 Byte) -----> RS-232C

ascout:	LD	D,A

	EXX
	LD	C,2
	EXX

	SRL	A
	SRL	A
	SRL	A
	SRL	A


; A -----> ASCII-Code(1 Byte) -----> RS-232C

ascou2:	CP	0AH
	JR	C,asco01
	ADD	A,7
asco01:	ADD	A,30H


; A -----> RS-232C

txout:	EX	AF,AF'
	LD	IX,pnt34
	LD	BC,0
asco02:	EI
	NOP
asco03:	DI
	DEC	BC
	LD	A,B
	OR	C
	JP	Z,txou10
	IN	A,(sioac)
	AND	04H
	JR	Z,asco02
	EX	AF,AF'
	OUT	(sioad),A

	EXX
	DEC	C
	LD	A,C
	EXX
	OR	A
	JP	Z,asco09

	LD	A,D
	AND	0FH
	JP	ascou2


asco09:	LD	SP,IY
	RET


txou10:	EX	AF,AF'
	JP	asco09


; ///// Return Address Table /////

pnt34	DW	asco03



; =====================================
; ====    Back-Light On/Off Sub    ====
; =====================================

light:	LD	IX,pnt45
	LD	BC,0000

ligh01:	IN	A,(sioac)
	AND	01
	JR	NZ,ligh10
	EI
	NOP
ligh02:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,ligh01

ligh09:	JP	slus19


ligh10:	IN	A,(sioad)
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,ligh1Z
	RES	7,L
	CP	00010000B
	JR	Z,ligh1Z
	RES	6,L
	CP	00100000B
	JR	Z,ligh1Z
	RES	5,L
ligh1Z:
	LD	A,L

	LD	HL,pnt07
	JP	escdsp

ligh11:	CP	'0'
	JP	Z,ltoff
	CP	'1'
	JP	Z,lton
ligh19:	JP	ligh09


; ///// Return Address Table /////

pnt07	DW	ligh11
pnt45	DW	ligh02


; <<<<< Off >>>>>

ltoff:	LD	A,5
	OUT	(siobc),A
	LD	A,11100010B
	OUT	(siobc),A

	LD	A,ctcw2 AND 01111111B
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

	JP	ligh19


; <<<<< On >>>>>

lton:	LD	A,(memsw0)
	BIT	0,A
	JR	NZ,lton10

	LD	A,ctcw2
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

lton09:	JP	ligh19


lton10:	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
	JR	lton09



; =================================
; ====    Carsol On/Off Sub    ====
; =================================

carsol:	LD	IX,pnt51
	LD	BC,0000

ca01:	IN	A,(sioac)
	AND	1
	JP	NZ,ca10
	EI
	NOP
ca02:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,ca01

ca09:	JP	slus19


ca10:	IN	A,(sioad)
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,ca1Z
	RES	7,L
	CP	00010000B
	JR	Z,ca1Z
	RES	6,L
	CP	00100000B
	JR	Z,ca1Z
	RES	5,L
ca1Z:
	LD	A,L

	LD	HL,pnt13
	JP	escdsp

ca11:	CP	'0'		; Carsol Off
	JP	Z,caroff
	CP	'1'		; Carsol On
	JP	Z,caron
	CP	'2'		; Carsol Blink
	JP	Z,car_bl
	CP	'3'		; Carsol Under_bar
	JP	Z,car_bar
ca19:	JP	ca09


; ///// Return Address Table /////

pnt13	DW	ca11
pnt51	DW	ca02


; <<<<< Carsol Off >>>>>

caroff:	EXX
	LD	A,L
	EXX
	CP	gyou0
	JP	NC,caof10

caof01:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,caof01

	EXX
	RES	0,E
	RES	1,E
	LD	A,E
	EXX
	AND	00000011B
	OR	lcddon
	LD	(lcdir),A

caof09:	JP	ca19


caof10:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,caof10

	EXX
	RES	0,E
	RES	1,E
	LD	A,E
	EXX
	AND	00000011B
	OR	lcddon
	LD	(lcdir2),A

	JP	caof09


; <<<<< Carsol On >>>>>

caron:	IN	A,(moderg)
	BIT	5,A
	JR	NZ,caon02

	LD	IY,pnt87
	JP	carb00
caon01:	JR	caon03

caon02:	LD	IY,pnt88
	JP	carc00

caon03:	JP	ca19


; <<<<< Carsol Blink >>>>>

car_bl:
	IN	A,(moderg)
	SET	3,A
	LD	D,A
cabl01:
	LD	A,haltcr
	OUT	(contrg),A
	LD	A,D
	OUT	(moderg),A
	BIT	7,A
	JR	NZ,cabl02
	LD	A,wdtnot
	OUT	(contrg),A
	JR	cabl03
cabl02:
	LD	A,wdtpls
	OUT	(contrg),A
cabl03:
	EXX
	LD	A,E
	EXX
	AND	03
	JP	NZ,caron
	JP	caroff


; <<<<< Carsol Under_bar >>>>>

car_bar:
	IN	A,(moderg)
	RES	3,A
	LD	D,A
	JP	cabl01


; ///// Return Address Table /////

pnt87	DW	caon01
pnt88	DW	caon03



; =============================
; ====    Point Set Sub    ====
; =============================

pset:	LD	D,11000000B

pset01:	LD	IX,pnt57	; Rx-In ??
	LD	BC,0
pset02:	IN	A,(sioac)
	AND	01
	JP	NZ,pset10
	EI
	NOP
pset03:	DI
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,pset02

pset09:	JP	slus19


pset10:	IN	A,(sioad)	; Data In
	LD	L,A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	CP	00110000B
	JR	Z,pset1Z
	RES	7,L
	CP	00010000B
	JR	Z,pset1Z
	RES	6,L
	CP	00100000B
	JR	Z,pset1Z
	RES	5,L
pset1Z:
	LD	A,L

	LD	HL,pnt58
	JP	escdsp
pset11:	CP	'0'
	JR	NC,pset12
	JP	pset09
pset12:	CP	'9'+1
	JP	C,pset20
	JP	pset09


pset20:	SUB	30H		; arc-ASCII

pset21:	EX	AF,AF'
	LD	A,D
	AND	11000000B
	CP	11000000B
	JP	Z,pset22
	CP	10000000B
	JP	Z,pset23
	CP	01000000B
	JP	Z,pset24
	EX	AF,AF'
	JP	pset25

pset22:	EX	AF,AF'
	CP	gyou1
	JP	NC,pset09
	LD	B,A
	AND	A
	JR	Z,pset2B
	XOR	A
pset2C:	ADD	A,10
	DJNZ	pset2C
pset2B:	OR	D
	LD	D,A
	JP	pset25

pset23:	EX	AF,AF'
	ADD	A,D
	LD	D,A
	JP	pset25

pset24:	EX	AF,AF'
	LD	E,A

pset25:	LD	A,D
	SUB	01000000B
	LD	D,A
	AND	11000000B
	JP	NZ,pset01

	LD	A,D		; Check
	AND	00111111B
	CP	0
	JR	NC,pset26
	JP	pset09
pset26:	CP	keta
	JR	C,pset27
	JP	pset09

pset27:	LD	A,E
	CP	0
	JR	NC,pset28
	JP	pset09
pset28:	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,pset29
	LD	A,gyou0-1
	JR	pset2A
pset29:	LD	A,gyou1-1
pset2A:	CP	E
	JR	NC,pset30
	JP	pset09


pset30:	LD	A,D		; Set
	EXX
	LD	H,A
	EXX
	LD	A,E
	EXX
	LD	L,A
	EXX

	LD	IY,pnt79
	JP	carset

pset39:	JP	pset09


; ///// Return Address Table /////

pnt57	DW	pset03
pnt58	DW	pset11
pnt79	DW	pset39



; ==================================
; ====    Send Display Sub A    ====
; ==================================

sendA:	LD	IY,pnt86
	JP	send
senA01:	LD	IY,0
	JP	slus19


; ///// Return Address Table /////

pnt86	DW	senA01



; ==========================================
; ====    Escape Code Display Module    ====
; ==========================================

; Return Address -----> HL Register

escdsp:	LD	B,H		; Store Return Address
	LD	C,L		;     HL -----> BC

	EXX			; Store Data
	LD	C,A
	EXX

	LD	A,(memsw2)	; Control Code Display ??
	BIT	1,A
	JP	NZ,escd10

escd01:	EXX			; Load Data
	LD	A,C
	EXX

	LD	H,B		; Load Return Address
	LD	L,C		;     BC -----> HL

	LD	SP,HL
	RET


escd10:	EXX
	LD	A,C
	EXX

	CP	null		; Control Code ??
	JR	C,escd11
	CP	us+1
	JR	NC,escd11
	LD	IY,pnt15
	JP	cntchk

escd11:	EX	AF,AF'		; Data Display
	EXX
	LD	A,L
	EXX
	CP	gyou0
	JR	NC,escd14

escd12:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,escd12
	EX	AF,AF'
	LD	(lcdwd),A
	JR	escd15

escd14:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,escd14
	EX	AF,AF'
	LD	(lcdwd2),A

escd15:	EXX			; Carsol-X +1
	INC	H
	LD	A,H
	CP	keta
	JP	NC,escd20
escd13:	EXX

	LD	IY,pnt75
	JP	carset

escd19:	JP	escd01


escd20:	LD	H,0		; Carsol-Y +1
	INC	L
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,escd21
	LD	A,gyou0-1
	JR	escd22
escd21:	LD	A,gyou1-1
escd22:	CP	L
	JP	C,escd30
	JP	escd13


escd30:	LD	L,A
	LD	A,(memsw2)
	BIT	2,A
	JP	Z,escd3A
	EXX

	LD	A,5
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001000B
	OUT	(sioac),A

	LD	E,B

	LD	IY,pnt17
	JP	rollup

escd31:	LD	B,E

	LD	A,5
	OUT	(sioac),A
	EXX
	LD	A,D
	EXX
	AND	00110000B
	RLCA
	OR	10001010B
	OUT	(sioac),A

escd39:	JP	escd19

escd3A:	LD	H,0
	LD	L,0
	EXX
	JR	escd39


; ///// Return Address Table /////

pnt15	DW	escd11
pnt17	DW	escd31
pnt75	DW	escd19



; ***********************************************
; ******    RS-232C Mode Display Module    ******
; ***********************************************

rsmodd:	LD	A,(memsw0)
	BIT	1,A
	JP	Z,rsmodd2

rsm07:	LD	A,(lcdbfg2)	; Text Clear
	BIT	7,A
	JR	NZ,rsm07
	LD	A,lcdcls
	LD	(lcdir2),A

rsmodd2:
	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,rsmodd2
	LD	A,lcdcls
	LD	(lcdir),A

	LD	HL,rsmds
	LD	B,rsmde-rsmds
	LD	IY,pnt83
	JP	text
rsm201:	JP	C,rsm06
	JP	baud2
rsm202:	JP	C,rsm06
	JP	length2
rsm203:	JP	C,rsm06
	JP	stop2
rsm204:	JP	C,rsm06
	JP	parity2
rsm205:	JP	C,rsm06

rsm04:	LD	IY,pnt29
	JP	txtds2

rsm06:	JP	main08


; ///// Return Address Table /////

pnt29	DW	rsm06
pnt83	DW	rsm201


; ///// Text Data Table /////

rsmds	DB	0FFH,0FFH,' RS-232C߰ɤò ',0FFH,0FFH,'  '
rsmde	EQU	$

bauds	DB	'ްڰ= 2400ް'
	DB	'ްڰ= 4800ް'
	DB	'ްڰ= 9600ް'
	DB	'ްڰ=19200ް'

lends	DB	'ްޯ=5bit,'
	DB	'ްޯ=7bit,'
	DB	'ްޯ=6bit,'
	DB	'ްޯ=8bit,'

pards	DB	'è=Non'
	DB	'è=Odd'
	DB	'è=Non'
	DB	'è=Ev.'

stods	DB	' įޯ=1bit, '
	DB	' įޯ=1bit, '
	DB	'įޯ=1.5bit,'
	DB	' įޯ=2bit, '



; =======================================
; ====    Baud-Rate Display Sub 2    ====
; =======================================

baud2:	LD	HL,bauds
	LD	DE,15

	EXX
	LD	A,D
	EXX
	AND	11000000B
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	LD	B,A
	OR	A
	JR	Z,baud202
baud201:
	ADD	HL,DE
	DJNZ	baud201

baud202:
	LD	B,15
	LD	IY,pnt89
	JP	text

baud203:
	JP	rsm202


; ///// Return Address Table /////

pnt89	DW	baud203



; =====================================
; ====    Data Bit Length Sub 2    ====
; =====================================

length2:
	LD	HL,lends
	LD	DE,14

	EXX
	LD	A,D
	EXX
	AND	00110000B
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	LD	B,A
	OR	A
	JR	Z,len202
len201:	ADD	HL,DE
	DJNZ	len201

len202:	LD	B,14
	LD	IY,pnt90
	JP	text

len203:	JP	rsm203


; ///// Return Address Table /////

pnt90	DW	len203



; ====================================
; ====    Parity Display Sub 2    ====
; ====================================

parity2:
	LD	HL,pards
	LD	DE,9

	EXX
	LD	A,D
	EXX
	AND	00000011B
	LD	B,A
	OR	A
	JR	Z,pari202
pari201:
	ADD	HL,DE
	DJNZ	pari201

pari202:
	LD	B,9
	LD	IY,pnt92
	JP	text

pari203:
	JP	rsm205


; ///// Return Address Table /////

pnt92	DW	pari203



; ======================================
; ====    Stop-Bit Display Sub 2    ====
; ======================================

stop2:	LD	HL,stods
	LD	DE,17

	EXX
	LD	A,D
	EXX
	AND	00001100B
	SRL	A
	SRL	A
	LD	B,A
	OR	A
	JR	Z,stop202
stop201:
	ADD	HL,DE
	DJNZ	stop201

stop202:
	LD	B,17
	LD	IY,pnt91
	JP	text

stop203:
	JP	rsm204


; ///// Return Address Table /////

pnt91	DW	stop203



; *****************************************
; ******    RS-232C Connect Check    ******
; *****************************************

conchk:	LD	IY,pnt82
	JP	status
con01:	CP	0FFH
	JR	Z,con10

con09:	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A

	JP	main0A


con10:
	LD	A,1
	OUT	(sioac),A
	XOR	A
	OUT	(sioac),A
	EXX
	RES	6,E
	EXX

con11:	LD	A,(lcdbfg)	; Text Clear
	BIT	7,A
	JR	NZ,con11
	LD	A,lcdcls
	LD	(lcdir),A

	LD	HL,cond1s
	LD	B,cond1e-cond1s
	LD	IY,pnt14
	JP	text
con12:

	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	IN	A,(sioac)
	AND	00111000B
	EXX
	LD	C,A
	EXX

	BIT	5,A		; CTS
	JP	Z,ctsnot

con13:	BIT	4,A		; DSR
	JP	Z,dsrnot

con14:	BIT	3,A		; DCD
	JP	Z,dcdnot

con15:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,con15
	LD	A,lcdcl
	LD	(lcdir),A

	LD	HL,cond2s
	LD	B,cond2e-cond2s
	LD	IY,pnt30
	JP	text

con16:	LD	A,(memsw0)
	BIT	0,A
	JR	Z,con1E
	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
con1E:	LD	IX,pnt40
con17:	LD	BC,4000H
con19:	EI
	NOP
con1A:	DI
	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	IN	A,(sioac)
	AND	00111000B
	CP	00111000B
	JP	Z,con1D
	EXX
	CP	C
	EXX
	JP	NZ,con10
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,con19

	LD	A,5
	OUT	(siobc),A
	LD	A,11100010B
	OUT	(siobc),A

con1B:	LD	BC,4000H
con1C:	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	IN	A,(sioac)
	AND	00111000B
	CP	00111000B
	JP	Z,con1D
	EXX
	CP	C
	EXX
	JP	NZ,con10
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,con1C

	JP	con16

con1D:
	LD	A,1
	OUT	(sioac),A
	LD	A,00010100B
	OUT	(sioac),A

	JP	con09


; ///// Return Address Table /////

pnt14	DW	con12
pnt30	DW	con16
pnt40	DW	con1A
pnt82	DW	con01


; ///// Text Data Table /////

cond1s	DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
	DB	' RS-232C ߰ '
	DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
	DB	'     '
cond1e	EQU	$

cond2s	DB	' ޤ Non-Active ޽'
cond2e	EQU	$



; ==================================
; ====    CTS Not-Active Sub    ====
; ==================================

ctsnot:	EX	AF,AF'

	LD	HL,ctsds
	LD	B,ctsde-ctsds
	LD	IY,pnt37
	JP	text

ctsn01:	EX	AF,AF'
	JP	con13


; ///// Return Address Table /////

pnt37	DW	ctsn01


; ///// Text Data Table /////

ctsds	DB	'CTS,'
ctsde	EQU	$



; ==================================
; ====    DSR Not-Active Sub    ====
; ==================================

dsrnot:	EX	AF,AF'

	LD	HL,dsrds
	LD	B,dsrde-dsrds
	LD	IY,pnt38
	JP	text

dsrn01:	EX	AF,AF'
	JP	con14


; ///// Return Address Table /////

pnt38	DW	dsrn01


; ///// Text Data Table /////

dsrds	DB	'DSR,'
dsrde	EQU	$



; ==================================
; ====    DCD Not-Active Sub    ====
; ==================================

dcdnot:	EX	AF,AF'

	LD	HL,dcdds
	LD	B,dcdde-dcdds
	LD	IY,pnt39
	JP	text

dcdn01:	EX	AF,AF'
	JP	con15


; ///// Return Address Table /////

pnt39	DW	dcdn01


; ///// Text Data Table /////

dcdds	DB	'DCD '
dcdde	EQU	$



; ***************************************************
; ******    Text Data Display & Twinkle Sub    ******
; ***************************************************

; HL	:	Text Data Start Address
; B	:	          Size

txtdsp:
	LD	IX,pntA4
	EI
	NOP
txtd04:	DI
	EXX
	BIT	6,E
	EXX
	JP	NZ,txtd10
	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,txtdsp
	LD	A,(HL)
	LD	(lcdwd),A
	INC	HL
	DJNZ	txtdsp

txtds2:	LD	DE,pnt26
	JP	twinkl
txtd01:	JP	C,txtd10

	LD	DE,2
	LD	BC,0

txtds3:
	LD	A,(memsw0)
	BIT	0,A
	JR	Z,txtd05

	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
	JR	txtd02
txtd05:
	LD	A,ctcw2
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

txtd02:
	LD	IX,pntA5
	EI
	NOP
txtd03:	DI
	EXX
	BIT	6,E
	EXX
	JP	NZ,txtd10
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,txtd02
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,txtd02

	OR	A

txtd09:
	LD	SP,IY
	RET


txtd10:
	SCF
	JR	txtd09


; ///// Return Address Table /////

pnt26	DW	txtd01
pntA4	DW	txtd04
pntA5	DW	txtd03


; =========================================
; ====    Twinkle Back-Light Module    ====
; =========================================

; DE	:	Return Address Pointer

twinkl:	LD	HL,7

twin00:	LD	A,(memsw0)
	BIT	0,A
	JR	Z,twin0B
	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
	JR	twin06
twin0B:
	LD	A,ctcw2
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

twin06:
twin04:	LD	BC,1000H
twin01:	LD	IX,pntA8
	EI
	NOP
twin02:	DI
	EXX
	BIT	6,E
	EXX
	JP	NZ,twin10
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,twin01

	LD	A,5
	OUT	(siobc),A
	LD	A,11100010B
	OUT	(siobc),A

	LD	A,ctcw2 AND 01111111B
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

twin05:	LD	BC,1000H
twin03:	LD	IX,pntA9
	EI
	NOP
twin0C:	DI
	EXX
	BIT	6,E
	EXX
	JP	NZ,twin10
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,twin03

	DEC	HL
	LD	A,H
	OR	L
	JP	NZ,twin00

twin09:	LD	A,(memsw0)
	BIT	0,A
	JR	Z,twin0D

	LD	A,5
	OUT	(siobc),A
	LD	A,01100000B
	OUT	(siobc),A
	JR	twin0A
twin0D:
	LD	A,ctcw2
	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

twin0A:	LD	H,D
	LD	L,E
	OR	A

twin0E:
	LD	SP,HL
	RET


twin10:
	LD	H,D
	LD	L,E
	SCF
	JR	twin0E


; ///// Return Address Table /////

pnt43	DW	twin02
pntA8	DW	twin02
pntA9	DW	twin0C



; *****************************************
; ******    Text Data Display Sub    ******
; *****************************************

; HL	:	Text Data Start Address
; B	:	          Size

text:	LD	IX,pntA6
	EI
	NOP
text01:	DI
	EXX
	BIT	6,E
	EXX
	JR	NZ,text10
	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,text
	LD	A,(HL)
	LD	(lcdwd),A
	INC	HL
	DJNZ	text
	OR	A
text09:	LD	SP,IY
	RET


text10:	SCF
	JR	text09


; ///// Return Address Table /////

pntA6	DW	text01



; ******************************************
; ******    Text Data Display Sub 2   ******
; ******************************************

; ----- TLX-40A Under 2 -----

; HL	:	Text Data Start Address
; B	:	          Size

text2:	LD	IX,pntA7
	EI
	NOP
tex201:	DI
	EXX
	BIT	6,E
	EXX
	JR	NZ,tex210
	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,text2
	LD	A,(HL)
	LD	(lcdwd2),A
	INC	HL
	DJNZ	text2
	OR	A
tex209:	LD	SP,IY
	RET


tex210:	SCF
	JR	tex209


; ///// Return Address Table /////

pntA7	DW	tex201



; *******************************************
; ******    SIO Status Check Module    ******
; *******************************************

status:	LD	A,(memsw1)
	BIT	2,A
	JR	Z,sta02

	XOR	A		; Reset
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A

	IN	A,(sioac)	; Status Check
	AND	00111000B
	CP	00111000B
	JR	NZ,sta01

	XOR	A		; Reset
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
sta02:	XOR	A

sta09:	LD	SP,IY
	RET


sta01:	XOR	A		; Reset
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	LD	A,0FFH
	JR	sta09



; ***********************************************
; ******    SIO Status Interrupt Module    ******
; ***********************************************

staint:
	LD	A,(memsw1)
	BIT	2,A
	JP	Z,staint20

	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	IN	A,(sioac)
	BIT	4,A
	JR	Z,staint10

staint01:
	LD	A,HIGH vcttbl
	LD	I,A

	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A

	LD	SP,IX
staint02:
	RETI



staint10:
	LD	A,223
	LD	I,A
staint16:
	JR	$+2
	LD	A,0
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A
	IN	A,(sioac)
	BIT	4,A
	JP	NZ,staint01
	LD	A,I
	DEC	A
	LD	I,A
	JP	NZ,staint16

staint11:
	LD	A,HIGH vcttbl
	LD	I,A

	XOR	A
	OUT	(sioac),A
	LD	A,00010000B
	OUT	(sioac),A

	LD	A,1
	OUT	(sioac),A
	XOR	A
	OUT	(sioac),A

	LD	A,haltcr
	OUT	(contrg),A
	LD	A,00011011B
	OUT	(moderg),A
	LD	A,wdtnot
	OUT	(contrg),A

	EXX
	LD	H,0
	LD	L,0
	LD	E,0
	EXX

staint12:
	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,staint12
	LD	A,lcddon
	LD	(lcdir),A

	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,staint13
	JP	staint15

staint13:
	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,staint13
	LD	A,lcdcls
	LD	(lcdir2),A

staint14:
	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,staint14
	LD	A,lcddon
	LD	(lcdir2),A

staint15:
	LD	SP,pntsta

	JR	staint02



staint20:
	LD	A,1
	OUT	(sioac),A
	LD	A,00010100B
	OUT	(sioac),A
	JP	staint01



; ///// Return Address Table /////

pntsta	DW	main09



; **********************************************
; ******    SIO Error Interrupt Module    ******
; **********************************************

sioerr:	IN	A,(sioad)	; Dummy Read

	XOR	A
	OUT	(sioac),A
	LD	A,00110000B
	OUT	(sioac),A

	LD	SP,IX
	RETI



; ******************************************
; ******    SIO-A Interrupt Module    ******
; ******************************************

sioint:	EXX
	SET	6,E
	EXX
	LD	SP,IX
	RETI



; ********************************************
; ******    EL-Inv. Interrupt Module    ******
; ********************************************

elint:	LD	A,5		; EL-Back-Light
	OUT	(siobc),A
	LD	A,11100010B
	OUT	(siobc),A

	LD	A,5
	OUT	(siobc),A

	EXX
	BIT	7,E
	JR	NZ,elint1
	LD	A,11100000B
	SET	7,E
	JR	elint2
elint1:	LD	A,01100010B
	RES	7,E
elint2:	EXX
	OUT	(siobc),A

elint9:	LD	SP,IX
	RETI



; ****************************************
; ******    Key Repeat Interrupt    ******
; ****************************************

ctc3_int:
	EXX			; L[͕s̎
	LD	A,E
	EXX
	AND	00110000b
	CP	00010000b
	JR	Z,ct3in01

	EXX
	RES	4,E
	RES	5,E
	EXX

ct3in01:
	LD	SP,IX
	RETI



; **********************************************
; ******    Registor Initialize Module    ******
; **********************************************

regini:	LD	A,0
	LD	BC,0
	LD	DE,0
	LD	HL,0

	EX	AF,AF'
	EXX
	LD	A,0
	LD	BC,0
	LD	DE,0
	LD	HL,0
	EXX
	EX	AF,AF'

	LD	IX,0
	LD	IY,0

	JP	main00



; *****************************************
; ******    PIO Initialize Module    ******
; *****************************************

; ///// Constant Diffinition /////

pioad	EQU	1CH		; PIO A-port Data
pioac	EQU	1DH		;            Command
piobd	EQU	1EH		;     B-port Data
piobc	EQU	1FH		;            Command


; ///// Program /////

pioini:	LD	A,(memsw3)
	BIT	0,A
	JP	NZ,pioi10

	LD	C,pioac
	LD	B,3
	LD	HL,pioacw
	OTIR

pioi01:	LD	C,piobc
	LD	B,3
	LD	HL,piobcw
	OTIR

	XOR	A
	OUT	(pioad),A

	JP	main01


pioi10:	LD	A,11001111B
	OUT	(pioac),A
	LD	A,(memsw3)
	BIT	2,A
	JR	Z,pioi11
	BIT	1,A
	JR	Z,pioi12
	LD	A,11111111B
	JR	pioi13
pioi11:	LD	A,00001111B
	JR	pioi13
pioi12:	LD	A,00111111B
pioi13:	OUT	(pioac),A
	LD	A,00010111B
	OUT	(pioac),A
	JP	pioi01


; ///// Command Data /////

pioacw	DB	11001111B	; PIO A-port Mode-3
	DB	00001111B	;            Out & In
	DB	00010111B	;            Non-Int.

piobcw	DB	11001111B	; PIO B-port Mode3
	DB	11111111B	;            In
	DB	00010111B	;            Non-int.



; ******************************************
; ******    Read DIP-Switch Module    ******
; ******************************************

swread:	LD	A,(memsw1)
	BIT	0,A
	JP	Z,swrd10

	LD	A,(memsw3)
	BIT	0,A
	JR	Z,swrd01
	AND	00000110B
	OR	A
	JP	NZ,swrd10

swrd01:	LD	A,11001111B
	OUT	(pioac),A
	LD	A,00000111B
	OUT	(pioac),A
	XOR	A
	OUT	(pioad),A

	IN	A,(pioad)
	AND	00001000B
	OR	A
	JR	NZ,swrd01

swrd02:	IN	A,(piobd)
	CPL
	LD	D,A

	LD	BC,4000
swrd03:	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,swrd03

	IN	A,(piobd)
	CPL
	CP	D
	JP	NZ,swrd02

	LD	A,D
	EXX
	LD	D,A
	EXX

	LD	A,11001111B
	OUT	(pioac),A
	LD	A,00001111B
	OUT	(pioac),A

swrd09:	JP	main02


swrd10:	LD	A,(rsmode)
	EXX
	LD	D,A
	EXX
	JP	swrd09



; *****************************************
; ******    CTC Initialize Module    ******
; *****************************************

; ///// Constant Diffinition /////

ctc0	EQU	10H		; CTC Channel-0
ctc1	EQU	11H		;             1
ctc2	EQU	12H		;             2
ctc3	EQU	13H		;             3

ctcw0	EQU	00010111B	; CTC Command CH-0
ctcw1	EQU	00010111B	;                1
ctcw2	EQU	11010111B	;                2
ctcw30	EQU	11000111B	;                3
ctcw32	EQU	00100111B	;                3

const0	EQU	0		; Constant Data CH-0
const1	EQU	0		;                  1
const2	EQU	4		;                  2
const30	EQU	30		;                  3
const31	EQU	150		;                  3
const32	EQU	19		;                  3

ctc_stop	EQU	01000011B


; ///// Program /////

ctcini:	LD	A,ctcw0		; RS-232C Baud-Rate
	OUT	(ctc0),A
	EXX
	LD	A,D
	EXX
	AND	11000000B
	RLCA
	RLCA
	INC	A
	LD	B,A
	LD	A,10H
ctcin0:	SRL	A
	DJNZ	ctcin0
	OUT	(ctc0),A
	LD	HL,vcttbl+8*2
	LD	A,L
	OUT	(ctc0),A

	LD	A,ctcw1		; EL-Inv.  300(Hz)
	OUT	(ctc1),A
	LD	A,const1
	OUT	(ctc1),A
	LD	A,ctcw2
	LD	D,A
	LD	A,(memsw0)
	BIT	0,A
	LD	A,D
	JR	Z,ctcin1
	AND	01111111B
ctcin1:	OUT	(ctc2),A
	LD	A,const2
	OUT	(ctc2),A

	LD	A,ctc_stop
	OUT	(ctc3),A

	JP	main03



; *****************************************
; ******    SIO Initialize Module    ******
; *****************************************

; ///// Constant Diffinition /////

sioad	EQU	18H		; SIO Channel-A Data
sioac	EQU	19H		;               Command
siobd	EQU	1AH		;     Channel-B Data
siobc	EQU	1BH		;               Command


; ///// Program /////

sioini:	LD	HL,sioacw1
	LD	B,sioace1-sioacw1+1
	LD	C,sioac
	OTIR

	EXX
	LD	A,D
	EXX
	AND	00001111B
	LD	D,A
	AND	00001100B
	OR	A
	LD	A,D
	JR	NZ,sioin1
	SET	2,A
sioin1:	OR	01100000B
	OUT	(sioac),A

	LD	HL,sioacw2
	LD	B,sioace2-sioacw2+1
	LD	C,sioac
	OTIR

	EXX
	LD	A,D
	EXX
	AND	00110000B
	LD	D,A
	RLCA
	RLCA
	LD	B,A
	LD	A,(memsw1)
	BIT	2,A
	JR	NZ,sioin2
	LD	A,00000001B	;  Ȱ 
	JR	sioin3
sioin2:
	LD	A,00100001B	;  Ȱ 
sioin3:
	OR	B
	OUT	(sioac),A

	LD	A,5
	OUT	(sioac),A

	LD	A,D
	RLCA
	OR	10001010B
	OUT	(sioac),A

	LD	HL,siobcw
	LD	B,siobce-siobcw+1
	LD	C,siobc
	OTIR

	IN	A,(sioad)
	IN	A,(sioad)
	IN	A,(sioad)

	JP	main04


; ///// Command Data /////

sioacw1	DB	00011000B	; Channel Reset
	DB	00000000B	; Null
sioace1	DB	00000100B	; Channel 4
	DB	00000000B	; Dummy
sioacw2	DB	00000001B	; Channel 1
	DB	00010100B	; Int.
sioace2	DB	00000011B	; Channel 3


siobcw	DB	00011000B	; Channel Reset
	DB	00000000B	; Null
	DB	00000100B	; Channel 4
	DB	00000000B	; Sync-Mode
	DB	00000101B	; Channel 5
	DB	11100010B	; RTS,DTR = Low
	DB	00000001B	; Channel 1
	DB	00000100B	; Non-Int.
	DB	00000010B	; Channel 2
siobce	DW	vcttbl



; *****************************************
; ******    LCD Initialize Module    ******
; *****************************************

; ///// Constant Diffinition /////

				; <Upper Module>
lcdir	EQU	6000H		; Instruction Register
lcdbfg	EQU	6001H		; Busy Flag
lcdwd	EQU	6002H		; LCD Data Write
lcdrd	EQU	6003H		;          Read

				; <Lower Module>
lcdir2	EQU	4000H		; Instruction Register
lcdbfg2	EQU	4001H		; Busy Flag
lcdwd2	EQU	4002H		; LCD Data Write
lcdrd2	EQU	4003H		;          Read

lcdcls	EQU	00000001B	; Clear Display
lcdhm	EQU	00000010B	; Return Home
lcdcl	EQU	00010000B	; Carsol Left
lcdcr	EQU	00010100B	;        Right
lcduhm	EQU	00H		; Home Address Over-Line
lcddhm	EQU	40H		;              Under-Line
lcduhm2	EQU	00H		; Home Address Over-Line(2)
lcddhm2	EQU	40H		;              Under-Line(2)
lcdbon	EQU	00001101B	; Blink On
lcdbof	EQU	00001100B	;       Off
lcdcon	EQU	00001110B	; Carsol On
lcdcof	EQU	00001100B	;        Off
lcddon	EQU	00001100B	; Display On
lcddof	EQU	00001000B	;         Off


; ///// Program /////

lcdini:	LD	HL,lcdic
	LD	B,lcdie-lcdic+1

lcdin0:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,lcdin0
	LD	A,(HL)
	LD	(lcdir),A
	INC	HL
	DJNZ	lcdin0

	LD	A,(memsw0)
	BIT	1,A
	JP	NZ,lcdin1

lcdin9:	JP	main0B


lcdin1:	LD	HL,lcdic
	LD	B,lcdie-lcdic+1

lcdin2:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,lcdin2
	LD	A,(HL)
	LD	(lcdir2),A
	INC	HL
	DJNZ	lcdin2

	JP	lcdin9


; ///// Instruction Data /////

lcdic	DB	00111100B	; 8-bit,2-line,5*10-dot
	DB	00000001B	; Clear Display
	DB	00000110B	; Non-Inc,Non-Shift
lcdie	DB	00001100B	; Display-On



; **************************************************
; ******    CG-RAM Initial Data Set Module    ******
; **************************************************

cgini:
	LD	A,(memsw2)
	BIT	1,A
	JP	Z,cgin09

	LD	DE,cntbl00
	LD	C,0

cgin01:	LD	A,(DE)
	CP	07
	JP	NZ,cgin10

cgin02:	INC	DE
	INC	C
	LD	A,C
	CP	20H
	JP	NZ,cgin01

cgin03:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cgin03
	LD	A,lcduhm OR 80H
	LD	(lcdir),A

	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,cgin04
	JR	cgin09

cgin04:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cgin04
	LD	A,lcduhm2 OR 80H
	LD	(lcdir2),A

cgin09:	JP	main05


cgin10:	LD	B,A
cgin11:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cgin11
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,cgin15
	JR	cgin16
cgin15:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cgin16
cgin16:	LD	A,B
	RLCA
	RLCA
	RLCA
	OR	01000000B
	LD	(lcdir),A
	LD	B,A
	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,cgin17
	JR	cgin18
cgin17:	LD	A,B
	LD	(lcdir2),A

cgin18:	LD	HL,cgtbl00
	LD	B,C
	LD	A,C
	OR	A
	JR	Z,cgin13
cgin12:	LD	A,8
	ADD	A,L
	LD	L,A
	XOR	A
	ADC	A,H
	LD	H,A
	DJNZ	cgin12

cgin13:	LD	B,8

cgin14:	LD	A,(lcdbfg)
	BIT	7,A
	JR	NZ,cgin14
	LD	A,(HL)
	LD	(lcdwd),A

	LD	A,(memsw0)
	BIT	1,A
	JR	NZ,cgin19
	JR	cgin1A

cgin19:	LD	A,(lcdbfg2)
	BIT	7,A
	JR	NZ,cgin19
	LD	A,(HL)
	LD	(lcdwd2),A

cgin1A:	INC	HL
	DJNZ	cgin14

	JP	cgin02



; ***************************************
; ******    Dummy Interrupt Sub    ******
; ***************************************

dmyirt:	LD	SP,IX
	RETI



; *******************************************
; ******    Function Key Text Table    ******
; *******************************************

	ORG	1EA0H

func_text0:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'0'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text1:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'1'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text2:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'2'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text3:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'3'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text4:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'4'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text5:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'5'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text6:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'6'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text7:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'7'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text8:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'8'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data

func_text9:
	DB	5		; Byte (0-15)
	DB	ec		; Text_Top_Data
	DB	'/'
	DB	'F'
	DB	'9'
	DB	cr
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H
	DB	00H		; Text_End_Data



; *****************************
; ******    Key Table    ******
; *****************************

	ORG	1F40H

; ---------- Shift Out ----------

ktbl00	DB	00FH		; Shift in
ktbl01	DB	041H		; 'A'
ktbl02	DB	042H		; 'B'
ktbl03	DB	020H		; ' '
ktbl04	DB	030H		; '0'
ktbl05	DB	02EH		; '.'
ktbl06	DB	01DH		; <-
ktbl07	DB	01CH		;  ->
ktbl08	DB	043H		; 'C'
ktbl09	DB	044H		; 'D'
ktbl0A	DB	045H		; 'E'
ktbl0B	DB	046H		; 'F'
ktbl0C	DB	031H		; '1'
ktbl0D	DB	032H		; '2'
ktbl0E	DB	033H		; '3'
ktbl0F	DB	01FH		;  v

ktbl10	DB	047H		; 'G'
ktbl11	DB	048H		; 'H'
ktbl12	DB	049H		; 'I'
ktbl13	DB	04AH		; 'J'
ktbl14	DB	034H		; '4'
ktbl15	DB	035H		; '5'
ktbl16	DB	036H		; '6'
ktbl17	DB	01EH		;  ^
ktbl18	DB	04BH		; 'K'
ktbl19	DB	04CH		; 'L'
ktbl1A	DB	04DH		; 'M'
ktbl1B	DB	011H		; Function
ktbl1C	DB	037H		; '7'
ktbl1D	DB	038H		; '8'
ktbl1E	DB	039H		; '9'
ktbl1F	DB	00DH		; Ret(Cariadge Return)

ktbl20	DB	00FH		; Shift in
ktbl21	DB	041H		; 'A'
ktbl22	DB	042H		; 'B'
ktbl23	DB	020H		; ' '
ktbl24	DB	030H		; '0'
ktbl25	DB	02EH		; '.'
ktbl26	DB	01DH		; <-
ktbl27	DB	01CH		;  ->
ktbl28	DB	043H		; 'C'
ktbl29	DB	044H		; 'D'
ktbl2A	DB	045H		; 'E'
ktbl2B	DB	046H		; 'F'
ktbl2C	DB	031H		; '1'
ktbl2D	DB	032H		; '2'
ktbl2E	DB	033H		; '3'
ktbl2F	DB	01FH		;  v

ktbl30	DB	047H		; 'G'
ktbl31	DB	048H		; 'H'
ktbl32	DB	049H		; 'I'
ktbl33	DB	04AH		; 'J'
ktbl34	DB	034H		; '4'
ktbl35	DB	035H		; '5'
ktbl36	DB	036H		; '6'
ktbl37	DB	01EH		;  ^
ktbl38	DB	04BH		; 'K'
ktbl39	DB	04CH		; 'L'
ktbl3A	DB	04DH		; 'M'
ktbl3B	DB	011H		; Function
ktbl3C	DB	037H		; '7'
ktbl3D	DB	038H		; '8'
ktbl3E	DB	039H		; '9'
ktbl3F	DB	00DH		; Ret(Cariadge Return)


; ---------- Shift In ----------

ktbl40	DB	00EH		; Shift Out
ktbl41	DB	04EH		; 'N'
ktbl42	DB	04FH		; 'O'
ktbl43	DB	02AH		; '*'
ktbl44	DB	030H		; '0'
ktbl45	DB	02EH		; '.'
ktbl46	DB	01DH		; <-
ktbl47	DB	01CH		;  ->
ktbl48	DB	050H		; 'P'
ktbl49	DB	051H		; 'Q'
ktbl4A	DB	052H		; 'R'
ktbl4B	DB	053H		; 'S'
ktbl4C	DB	031H		; '1'
ktbl4D	DB	032H		; '2'
ktbl4E	DB	033H		; '3'
ktbl4F	DB	01FH		;  v

ktbl50	DB	054H		; 'T'
ktbl51	DB	055H		; 'U'
ktbl52	DB	056H		; 'V'
ktbl53	DB	057H		; 'W'
ktbl54	DB	034H		; '4'
ktbl55	DB	035H		; '5'
ktbl56	DB	036H		; '6'
ktbl57	DB	01EH		;  ^
ktbl58	DB	058H		; 'X'
ktbl59	DB	059H		; 'Y'
ktbl5A	DB	05AH		; 'Z'
ktbl5B	DB	023H		; '#'
ktbl5C	DB	037H		; '7'
ktbl5D	DB	038H		; '8'
ktbl5E	DB	039H		; '9'
ktbl5F	DB	010H		; Send(Data Link Escape)

ktbl60	DB	00EH		; Shift Out
ktbl61	DB	04EH		; 'N'
ktbl62	DB	04FH		; 'O'
ktbl63	DB	02AH		; '*'
ktbl64	DB	030H		; '0'
ktbl65	DB	02EH		; '.'
ktbl66	DB	01DH		; <-
ktbl67	DB	01CH		;  ->
ktbl68	DB	050H		; 'P'
ktbl69	DB	051H		; 'Q'
ktbl6A	DB	052H		; 'R'
ktbl6B	DB	053H		; 'S'
ktbl6C	DB	031H		; '1'
ktbl6D	DB	032H		; '2'
ktbl6E	DB	033H		; '3'
ktbl6F	DB	01FH		;  v

ktbl70	DB	054H		; 'T'
ktbl71	DB	055H		; 'U'
ktbl72	DB	056H		; 'V'
ktbl73	DB	057H		; 'W'
ktbl74	DB	034H		; '4'
ktbl75	DB	035H		; '5'
ktbl76	DB	036H		; '6'
ktbl77	DB	01EH		;  ^
ktbl78	DB	058H		; 'X'
ktbl79	DB	059H		; 'Y'
ktbl7A	DB	05AH		; 'Z'
ktbl7B	DB	023H		; '#'
ktbl7C	DB	037H		; '7'
ktbl7D	DB	038H		; '8'
ktbl7E	DB	039H		; '9'
ktbl7F	DB	010H		; Send(Data Link Escape)



; ****************************************
; ******    CG-RAM Address Table    ******
; ****************************************

	ORG	1FC0H

cntbl00	DB	00		; NL / Null
cntbl01	DB	07		; SH / Start of Heading
cntbl02	DB	01		; SX / Start of Text
cntbl03	DB	02		; EX / End of Text
cntbl04	DB	07		; ET / End of transmission
cntbl05	DB	07		; EQ / Enquity
cntbl06	DB	03		; AK / Acknowledge
cntbl07	DB	07		; BL / Bell
cntbl08	DB	07		; BS / Back Space
cntbl09	DB	07		; HT / Horizontal Tabulation
cntbl0A	DB	04		; LF / Line Feed
cntbl0B	DB	07		; HM / Home Vertical Tabulation
cntbl0C	DB	07		; CL / Clear Form Feed
cntbl0D	DB	05		; CR / Carriage Return
cntbl0E	DB	07		; SO / Sift-out
cntbl0F	DB	07		; SI / Sift-in

cntbl10	DB	07		; DE / Data Link Escape
cntbl11	DB	07		; D1 / Device Control 1
cntbl12	DB	07		; D2 / Device Control 2
cntbl13	DB	07		; D3 / Device Control 3
cntbl14	DB	07		; D4 / Device Control 4
cntbl15	DB	06		; NK / Negative Acknowledge
cntbl16	DB	07		; SN / Synchronous idle
cntbl17	DB	07		; EB / End of Transmision Block
cntbl18	DB	07		; CN / Cancel
cntbl19	DB	07		; EM / End of Medium
cntbl1A	DB	07		; SB / Substitute
cntbl1B	DB	07		; EC / Escape
cntbl1C	DB	07		; FS / File Separator(->)
cntbl1D	DB	07		; GS / Group Separator(<-)
cntbl1E	DB	07		; RS / Record Separator(^)
cntbl1F	DB	07		; US / Unit Separator



; *****************************************
; ******    System Mode Data Area    ******
; *****************************************

	ORG	1FE0H

		DB	00		; 
rsmode		DB	10110100B	; RS-232C Mode Data
rep_time0	DB	const30		; Key Repeat 0
rep_time1	DB	const31		;            1
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 
		DB	00		; 



; **************************************
; ******    Memory Switch Area    ******
; **************************************

	ORG	1FF0H

memsw0	DB	00000011B		; LCD Control
memsw1	DB	00010100B		; RS-232C
memsw2	DB	00001101B		; Display
memsw3	DB	00001011B		; Switch
memsw4	DB	00000000B		; 
memsw5	DB	00000000B		; 
memsw6	DB	00000000B		; 
memsw7	DB	00000000B		; 
memsw8	DB	00000000B		; 
memsw9	DB	00000000B		; 
memswA	DB	00000000B		; 
memswB	DB	00000000B		; 
memswC	DB	00000000B		; 
memswD	DB	00000000B		; 
memswE	DB	00000000B		; 
memswF	DB	00000000B		; 



prgend:	
	END
